package techreborn.tiles.teir1;

import reborncore.common.IWrenchable;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.FurnaceRecipes;
import net.minecraft.util.EnumFacing;
import reborncore.api.power.EnumPowerTier;
import reborncore.api.tile.IInventoryProvider;
import reborncore.common.blocks.BlockMachineBase;
import reborncore.common.powerSystem.TilePowerAcceptor;
import reborncore.common.util.Inventory;
import techreborn.init.ModBlocks;

public class TileElectricFurnace extends TilePowerAcceptor implements IWrenchable,IInventoryProvider, ISidedInventory
{

	public Inventory inventory = new Inventory(6, "TileElectricFurnace", 64, this);
	public int capacity = 1000;
	public int progress;
	public int fuelScale = 100;
	public int cost = 10;
	int input1 = 0;
	int output = 1;

	public TileElectricFurnace()
	{
		super(1);
	}

	public int gaugeProgressScaled(int scale)
	{
		return (progress * scale) / fuelScale;
	}

	@Override
	public void updateEntity()
	{
		boolean burning = isBurning();
		boolean updateInventory = false;
		if (getEnergy() <= cost && canSmelt())
		{
			if (getEnergy() > cost)
			{
				updateInventory = true;
			}
		}
		if (isBurning() && canSmelt())
		{
			updateState();

			progress++;
			if (progress >= fuelScale)
			{
				progress = 0;
				cookItems();
				updateInventory = true;
			}
		} else
		{
			progress = 0;
			updateState();
		}
		if (burning != isBurning())
		{
			updateInventory = true;
		}
		if (updateInventory)
		{
			func_70296_d();
		}
	}

	public void cookItems()
	{
		if (this.canSmelt())
		{
			ItemStack itemstack = FurnaceRecipes.func_77602_a().func_151395_a(func_70301_a(input1));

			if (func_70301_a(output) == null)
			{
				useEnergy(cost);
				func_70299_a(output, itemstack.func_77946_l());
			} else if (func_70301_a(output).func_77969_a(itemstack))
			{
				useEnergy(cost);
				func_70301_a(output).field_77994_a += itemstack.field_77994_a;
			}
			if (func_70301_a(input1).field_77994_a > 1)
			{
				useEnergy(cost);
				this.func_70298_a(input1, 1);
			} else
			{
				useEnergy(cost);
				func_70299_a(input1, null);
			}
		}
	}

	public boolean canSmelt()
	{
		if (func_70301_a(input1) == null)
		{
			return false;
		} else
		{
			ItemStack itemstack = FurnaceRecipes.func_77602_a().func_151395_a(func_70301_a(input1));
			if (itemstack == null)
				return false;
			if (func_70301_a(output) == null)
				return true;
			if (!func_70301_a(output).func_77969_a(itemstack))
				return false;
			int result = func_70301_a(output).field_77994_a + itemstack.field_77994_a;
			return (result <= func_70297_j_() && result <= itemstack.func_77976_d());
		}
	}

	public boolean isBurning()
	{
		return getEnergy() > cost;
	}

	public ItemStack getResultFor(ItemStack stack)
	{
		ItemStack result = FurnaceRecipes.func_77602_a().func_151395_a(stack);
		if (result != null)
		{
			return result.func_77946_l();
		}
		return null;
	}

	public void updateState()
	{
		IBlockState BlockStateContainer = field_145850_b.func_180495_p(field_174879_c);
		if (BlockStateContainer.func_177230_c() instanceof BlockMachineBase)
		{
			BlockMachineBase blockMachineBase = (BlockMachineBase) BlockStateContainer.func_177230_c();
			if (BlockStateContainer.func_177229_b(BlockMachineBase.ACTIVE) != progress > 0)
				blockMachineBase.setActive(progress > 0, field_145850_b, field_174879_c);
		}
	}

	@Override
	public boolean wrenchCanSetFacing(EntityPlayer entityPlayer, EnumFacing side)
	{
		return false;
	}

	@Override
	public EnumFacing getFacing()
	{
		return getFacingEnum();
	}

	@Override
	public boolean wrenchCanRemove(EntityPlayer entityPlayer)
	{
		return entityPlayer.func_70093_af();
	}

	@Override
	public float getWrenchDropRate()
	{
		return 1.0F;
	}

	@Override
	public ItemStack getWrenchDrop(EntityPlayer entityPlayer)
	{
		return new ItemStack(ModBlocks.ElectricFurnace, 1);
	}

	public boolean isComplete()
	{
		return false;
	}

	// ISidedInventory
	@Override
	public int[] func_180463_a(EnumFacing side)
	{
		return side == EnumFacing.DOWN ? new int[] { 0, 1, 2 } : new int[] { 0, 1, 2 };
	}

	@Override
	public boolean func_180462_a(int slotIndex, ItemStack itemStack, EnumFacing side)
	{
		if (slotIndex == 2)
			return false;
		return func_94041_b(slotIndex, itemStack);
	}

	@Override
	public boolean func_180461_b(int slotIndex, ItemStack itemStack, EnumFacing side)
	{
		return slotIndex == 2;
	}

	@Override
	public double getMaxPower()
	{
		return capacity;
	}

	@Override
	public boolean canAcceptEnergy(EnumFacing direction)
	{
		return true;
	}

	@Override
	public boolean canProvideEnergy(EnumFacing direction)
	{
		return false;
	}

	@Override
	public double getMaxOutput()
	{
		return 0;
	}

	@Override
	public double getMaxInput()
	{
		return 32;
	}

	@Override
	public EnumPowerTier getTier()
	{
		return EnumPowerTier.LOW;
	}

	@Override
	public Inventory getInventory() {
		return inventory;
	}
}
