package techreborn.init;

import net.minecraft.block.Block;
import net.minecraft.init.Blocks;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.oredict.OreDictionary;
import org.apache.commons.lang3.ArrayUtils;
import reborncore.api.recipe.RecipeHandler;
import reborncore.common.util.CraftingHelper;
import reborncore.common.util.OreUtil;
import reborncore.common.util.StringUtils;
import techreborn.Core;
import techreborn.api.ScrapboxList;
import techreborn.api.TechRebornAPI;
import techreborn.api.reactor.FusionReactorRecipe;
import techreborn.api.reactor.FusionReactorRecipeHelper;
import techreborn.api.recipe.RecyclerRecipe;
import techreborn.api.recipe.ScrapboxRecipe;
import techreborn.api.recipe.machines.*;
import techreborn.blocks.*;
import techreborn.config.ConfigTechReborn;
import techreborn.items.*;
import techreborn.parts.powerCables.ItemStandaloneCables;
import techreborn.utils.RecipeUtils;
import techreborn.utils.StackWIPHandler;

import java.security.InvalidParameterException;

public class ModRecipes
{
	public static ConfigTechReborn config;
	public static ItemStack hammerStack = new ItemStack(ModItems.hammer, 1, OreDictionary.WILDCARD_VALUE);
	public static ItemStack batteryStack = new ItemStack(ModItems.reBattery, 1, OreDictionary.WILDCARD_VALUE);
	public static ItemStack crystalStack = new ItemStack(ModItems.energyCrystal, 1, OreDictionary.WILDCARD_VALUE);
	public static ItemStack lapcrystalStack = new ItemStack(ModItems.lapotronCrystal, 1, OreDictionary.WILDCARD_VALUE);
	public static ItemStack dyes = new ItemStack(Items.field_151100_aR, 1, OreDictionary.WILDCARD_VALUE);
	public static Item hammer = ModItems.hammer;

	public static Item ironDrill = TechRebornAPI.recipeCompact.getItem("miningDrill").func_77973_b();
	public static ItemStack ironDrillStack = new ItemStack(ironDrill, 1, OreDictionary.WILDCARD_VALUE);

	public static Item diamondDrill = ModItems.diamondDrill;
	public static ItemStack diamondDrillStack = new ItemStack(diamondDrill, 1, OreDictionary.WILDCARD_VALUE);

	public static Item ironChainsaw = ModItems.ironChainsaw;
	public static ItemStack ironChainsawStack = new ItemStack(ironChainsaw, 1, OreDictionary.WILDCARD_VALUE);

	public static Item diamondChainsaw = ModItems.diamondChainsaw;
	public static ItemStack diamondChainsawStack = new ItemStack(diamondChainsaw, 1, OreDictionary.WILDCARD_VALUE);

	public static void init()
	{
		addShapelessRecipes();
		addGeneralShapedRecipes();
		addMachineRecipes();

		addSmeltingRecipes();
		addUUrecipes();

		addAlloySmelterRecipes();
		addPlateCuttingMachineRecipes();
		addIndustrialCentrifugeRecipes();
		addChemicalReactorRecipes();
		addIndustrialElectrolyzerRecipes();

		addIndustrialSawmillRecipes();
		addBlastFurnaceRecipes();
		addIndustrialGrinderRecipes();
		addImplosionCompressorRecipes();
		addReactorRecipes();
		addIc2Recipes();
		addGrinderRecipes();
		// addHammerRecipes();
		addIc2ReplacementReicpes();
		addExtractorRecipes();
		addCompressorRecipes();
		addWireRecipes();
		addScrapBoxloot();
	}

	static void addScrapBoxloot()
	{
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151045_i));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151055_y));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151044_h));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151034_e));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151168_bH));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151065_br));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151015_O));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151172_bF));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151124_az));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_185153_aK));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_185151_aI));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_185154_aL));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_185152_aJ));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_185150_aH));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151072_bj));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151111_aL));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151148_bJ));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151026_S));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151031_f));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151077_bg));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151105_aU));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179572_au));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179571_av));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179568_as));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179567_at));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179570_aq));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179569_ar));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151053_p));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151017_I));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151039_o));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151038_n));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151041_m));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151104_aV));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151144_bL, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151144_bL, 1, 2));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151144_bL, 1, 4));
		for (int i = 0; i < StackWIPHandler.devHeads.size(); i++)
			ScrapboxList.addItemStackToList(StackWIPHandler.devHeads.get(i));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151100_aR, 1, 3));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151114_aO));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151007_F));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151143_au));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151108_aI));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151140_bW));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179562_cC));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151097_aZ));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151062_by));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151103_aS));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151054_z));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151118_aC));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151112_aM));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151122_aG));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151121_aF));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151102_aT));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151120_aE));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151070_bp));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151123_aH));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151078_bh));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151155_ap));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151099_bA));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151083_be));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151057_cb));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151141_av));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151137_ax));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151016_H));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179555_bs));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_179556_br));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151034_e));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151153_ao));
		ScrapboxList.addItemStackToList(new ItemStack(Items.field_151074_bl));

		ScrapboxList.addItemStackToList(ItemCells.getCellByName("empty"));
		ScrapboxList.addItemStackToList(ItemCells.getCellByName("water"));
		ScrapboxList.addItemStackToList(ItemParts.getPartByName("scrap"));
		ScrapboxList.addItemStackToList(ItemParts.getPartByName("rubber"));

		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150415_aT));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150430_aB));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150471_bO));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180405_aT));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180387_bt));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180404_aQ));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180392_bq));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180406_aS));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180385_bs));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180403_aR));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180386_br));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150386_bk));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180407_aO));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180390_bo));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180408_aP));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_180391_bp));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150336_V));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150462_ai));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150423_aK));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150424_aL));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150349_c));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150346_d, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150346_d, 1, 1));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150354_m, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150354_m, 1, 1));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150426_aN));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150351_n));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150405_ch));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150359_w));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150410_aZ));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150434_aF));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150329_H, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150329_H, 1, 1));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150330_I));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150486_ae));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150335_W));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150448_aq));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150319_E));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150318_D));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150408_cc));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150327_N));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 1));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 2));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 3));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 4));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 5));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 6));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 7));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150328_O, 1, 8));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150338_P));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150337_Q));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150420_aW));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150419_aX));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150345_g, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150345_g, 1, 1));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150345_g, 1, 2));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150345_g, 1, 3));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150345_g, 1, 4));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150345_g, 1, 5));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150362_t, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150362_t, 1, 1));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150362_t, 1, 2));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150362_t, 1, 3));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150361_u, 1, 0));
		ScrapboxList.addItemStackToList(new ItemStack(Blocks.field_150361_u, 1, 1));

		ScrapboxList.addItemStackToList(new ItemStack(ModBlocks.rubberSapling));

		for (String i : ItemDusts.types)
			ScrapboxList.addItemStackToList(ItemDusts.getDustByName(i));

		for (String i : ItemNuggets.types)
			ScrapboxList.addItemStackToList(ItemNuggets.getNuggetByName(i));

		for (String i : ItemGems.types)
			ScrapboxList.addItemStackToList(ItemGems.getGemByName(i));

		registerDyable(Blocks.field_150404_cg);
		registerDyable(Blocks.field_150399_cn);
		registerDyable(Blocks.field_150397_co);
		registerDyable(Blocks.field_150406_ce);

		for (int i = 0; i < ScrapboxList.stacks.size(); i++)
		{
			RecipeHandler.addRecipe(new ScrapboxRecipe(ScrapboxList.stacks.get(i)));
		}

		// just for jei
		// TODO find a way to get all ItemStacks in mc
		for (int i = 0; i < ScrapboxList.stacks.size(); i++)
		{
			RecipeHandler.addRecipe(new RecyclerRecipe(ScrapboxList.stacks.get(i)));
		}
	}

	static void registerMetadataItem(ItemStack item)
	{
		for (int i = 0; i < item.func_77973_b().func_77612_l(); i++)
		{
			ScrapboxList.addItemStackToList(new ItemStack(item.func_77973_b(), 1, i));
		}
	}

	static void registerDyable(Block block)
	{
		for (int i = 0; i < 16; i++)
			ScrapboxList.stacks.add(new ItemStack(block, 1, i));
	}

	static void addWireRecipes()
	{
		CraftingHelper.addShapedOreRecipe(ItemStandaloneCables.getCableByName("copper", 6), "CCC", 'C', "ingotCopper");
		CraftingHelper.addShapedOreRecipe(ItemStandaloneCables.getCableByName("tin", 9), "CCC", 'C', "ingotTin");
		CraftingHelper.addShapedOreRecipe(ItemStandaloneCables.getCableByName("gold", 12), "CCC", 'C', "ingotGold");
		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("hv", 12), "CCC", 'C', "ingotRefinedIron");

		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("glassfiber", 4), "GGG", "SDS", "GGG", 'G',
						"blockGlass", 'S', "dustRedstone", 'D', "diamondTR");

		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("glassfiber", 6), "GGG", "SDS", "GGG", 'G',
						"blockGlass", 'S', "dustRedstone", 'D', "gemRuby");

		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("glassfiber", 6), "GGG", "SDS", "GGG", 'G',
						"blockGlass", 'S', "ingotSilver", 'D', "diamondTR");
		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("glassfiber", 8), "GGG", "SDS", "GGG", 'G',
						"blockGlass", 'S', "ingotElectrum", 'D', "diamondTR");

		CraftingHelper.addShapelessOreRecipe(ItemStandaloneCables.getCableByName("insulatedcopper"), "materialRubber",
				ItemStandaloneCables.getCableByName("copper"));
		CraftingHelper.addShapelessOreRecipe(ItemStandaloneCables.getCableByName("insulatedgold"), "materialRubber",
				"materialRubber", ItemStandaloneCables.getCableByName("gold"));
		CraftingHelper.addShapelessOreRecipe(ItemStandaloneCables.getCableByName("insulatedhv"), "materialRubber",
				"materialRubber", ItemStandaloneCables.getCableByName("hv"));

		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("insulatedcopper", 6), "RRR", "III", "RRR", 'R',
						"materialRubber", 'I', "ingotCopper");
		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("insulatedgold", 4), "RRR", "RIR", "RRR", 'R',
						"materialRubber", 'I', "ingotGold");
		CraftingHelper
				.addShapedOreRecipe(ItemStandaloneCables.getCableByName("insulatedhv", 4), "RRR", "RIR", "RRR", 'R',
						"materialRubber", 'I', "ingotRefinedIron");
	}

	private static void addCompressorRecipes()
	{
		RecipeHandler.addRecipe(new CompressorRecipe(ItemIngots.getIngotByName("mixedmetal"),
				ItemIngots.getIngotByName("advancedAlloy"), 400, 20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemParts.getPartByName("carbonmesh"), ItemPlates.getPlateByName("carbon"), 400,
						20));

		RecipeHandler.addRecipe(
				new CompressorRecipe(new ItemStack(Items.field_151042_j), ItemPlates.getPlateByName("iron"), 400, 20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("copper"), ItemPlates.getPlateByName("copper"), 400,
						20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("tin"), ItemPlates.getPlateByName("tin"), 400, 20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("aluminum"), ItemPlates.getPlateByName("aluminum"), 400,
						20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("brass"), ItemPlates.getPlateByName("brass"), 400, 20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("bronze"), ItemPlates.getPlateByName("bronze"), 400,
						20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("lead"), ItemPlates.getPlateByName("lead"), 400, 20));
		RecipeHandler.addRecipe(
				new CompressorRecipe(ItemIngots.getIngotByName("silver"), ItemPlates.getPlateByName("silver"), 400,
						20));
	}

	static void addExtractorRecipes()
	{
		RecipeHandler.addRecipe(
				new ExtractorRecipe(ItemParts.getPartByName("rubberSap"), ItemParts.getPartByName("rubber", 3), 400,
						20));
		RecipeHandler.addRecipe(
				new ExtractorRecipe(new ItemStack(ModBlocks.rubberLog), ItemParts.getPartByName("rubber"), 400, 20, false));
	}

	static void addIc2ReplacementReicpes()
	{
		// TODO: Replace item pump with block
		/*CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("pump"), "CEC", "CMC", "PTP", 'C',
				ItemCells.getCellByName("empty"), 'T', new ItemStack(ModItems.treeTap), 'M', "machineBlockBasic", 'P',
				new ItemStack(Blocks.iron_bars), 'E', "circuitBasic");

		// TODO: Replace item teleporter with block
		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("teleporter"), "CTC", "WMW", "CDC", 'C', "circuitAdvanced",
						'T', new ItemStack(ModItems.frequencyTransmitter), 'M', "machineBlockAdvanced", 'W',
						ItemStandaloneCables.getCableByName("glassfiber"), 'D', "gemDiamond", 'E', "circuitBasic");
		*/
	}

	static void addGrinderRecipes()
	{
		// Vanilla
		RecipeHandler.addRecipe(
				new GrinderRecipe(new ItemStack(Blocks.field_150366_p), ItemDusts.getDustByName("iron", 2), 100, 20));
		RecipeHandler.addRecipe(
				new GrinderRecipe(new ItemStack(Blocks.field_150352_o), ItemDusts.getDustByName("gold", 2), 100, 20));
		RecipeHandler.addRecipe(new GrinderRecipe(new ItemStack(Items.field_151044_h), ItemDusts.getDustByName("coal"), 100, 20));
		RecipeHandler
				.addRecipe(new GrinderRecipe(new ItemStack(Blocks.field_150365_q), new ItemStack(Items.field_151044_h, 2), 100, 20));
		RecipeHandler.addRecipe(new GrinderRecipe(new ItemStack(Items.field_151103_aS), new ItemStack(Items.field_151100_aR, 6, 15), 100, 20));
		RecipeHandler
				.addRecipe(new GrinderRecipe(new ItemStack(Blocks.field_150347_e), new ItemStack(Blocks.field_150354_m), 100, 20));
		RecipeHandler.addRecipe(new GrinderRecipe(new ItemStack(Blocks.field_150351_n), new ItemStack(Items.field_151145_ak), 100, 20));

		// TechReborn
		RecipeHandler.addRecipe(
				new GrinderRecipe(BlockOre2.getOreByName("copper"), ItemDusts.getDustByName("copper", 2), 100, 20));
		RecipeHandler.addRecipe(
				new GrinderRecipe(BlockOre2.getOreByName("tin"), ItemDusts.getDustByName("tin", 2), 100, 20));
		RecipeHandler.addRecipe(
				new GrinderRecipe(BlockOre.getOreByName("Lead"), ItemDusts.getDustByName("lead", 2), 100, 20));
		RecipeHandler.addRecipe(
				new GrinderRecipe(BlockOre.getOreByName("Silver"), ItemDusts.getDustByName("silver", 2), 100, 20));
		RecipeHandler
				.addRecipe(new GrinderRecipe(ItemGems.getGemByName("ruby"), ItemDusts.getDustByName("ruby"), 100, 20));
	}

	// static void addHammerRecipes()
	// {
	// CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.hammer), "III",
	// "ISI", " S ", 'S', Items.stick, 'I',
	// "ingotIron");
	//
	// CraftingHelper.addShapelessOreRecipe(ItemPlates.getPlateByName("iron",
	// 1), hammerStack, "ingotIron");
	// CraftingHelper.addShapelessOreRecipe(ItemPlates.getPlateByName("copper",
	// 1), hammerStack, "ingotCopper");
	// CraftingHelper.addShapelessOreRecipe(ItemPlates.getPlateByName("tin", 1),
	// hammerStack, "ingotTin");
	// CraftingHelper.addShapelessOreRecipe(ItemPlates.getPlateByName("bronze",
	// 1), hammerStack, "ingotBronze");
	// CraftingHelper.addShapelessOreRecipe(ItemPlates.getPlateByName("brass",
	// 1), hammerStack, "ingotBrass");
	// CraftingHelper.addShapelessOreRecipe(ItemPlates.getPlateByName("steel",
	// 1), hammerStack, "ingotSteel");
	//
	// hammer.setContainerItem(hammer);
	// }

	static void addReactorRecipes()
	{
		FusionReactorRecipeHelper.registerRecipe(
				new FusionReactorRecipe(ItemCells.getCellByName("tritium"), ItemCells.getCellByName("deuterium"),
						ItemCells.getCellByName("helium"), 40000000, 32768, 1024));
		FusionReactorRecipeHelper.registerRecipe(
				new FusionReactorRecipe(ItemCells.getCellByName("tritium"), ItemCells.getCellByName("deuterium"),
						ItemCells.getCellByName("helium3"), 60000000, 32768, 2048));
		FusionReactorRecipeHelper.registerRecipe(
				new FusionReactorRecipe(ItemCells.getCellByName("wolframium"), ItemCells.getCellByName("Berylium"),
						ItemDusts.getDustByName("platinum"), 80000000, -2048, 1024));
	}

	static void addGeneralShapedRecipes()
	{

		// Storage Blocks
		for (String name : ArrayUtils.addAll(BlockStorage.types, BlockStorage2.types))
		{
			CraftingHelper.addShapedOreRecipe(BlockStorage.getStorageBlockByName(name), "AAA", "AAA", "AAA", 'A',
					"ingot" + name.substring(0, 1).toUpperCase() + name.substring(1));
		}
		CraftingHelper
				.addShapedOreRecipe(ItemCells.getCellByName("empty", 16, false), " T ", "T T", " T ", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.ironFence, 6), "   ", "RRR", "RRR", 'R',
				ItemIngots.getIngotByName("refinedIron"));

		addGemToolRecipes(new ItemStack(ModItems.rubySword), new ItemStack(ModItems.rubyPickaxe),
				new ItemStack(ModItems.rubyAxe), new ItemStack(ModItems.rubyHoe), new ItemStack(ModItems.rubySpade),
				new ItemStack(ModItems.rubyHelmet), new ItemStack(ModItems.rubyChestplate),
				new ItemStack(ModItems.rubyLeggings), new ItemStack(ModItems.rubyBoots), ItemGems.getGemByName("ruby"));

		addGemToolRecipes(new ItemStack(ModItems.sapphireSword), new ItemStack(ModItems.sapphirePickaxe),
				new ItemStack(ModItems.sapphireAxe), new ItemStack(ModItems.sapphireHoe),
				new ItemStack(ModItems.sapphireSpade), new ItemStack(ModItems.sapphireHelmet),
				new ItemStack(ModItems.sapphireChestplate), new ItemStack(ModItems.sapphireLeggings),
				new ItemStack(ModItems.sapphireBoots), ItemGems.getGemByName("sapphire"));

		addGemToolRecipes(new ItemStack(ModItems.peridotSword), new ItemStack(ModItems.peridotPickaxe),
				new ItemStack(ModItems.peridotAxe), new ItemStack(ModItems.peridotHoe),
				new ItemStack(ModItems.peridotSpade), new ItemStack(ModItems.peridotHelmet),
				new ItemStack(ModItems.peridotChestplate), new ItemStack(ModItems.peridotLeggings),
				new ItemStack(ModItems.peridotBoots), ItemGems.getGemByName("peridot"));

		addGemToolRecipes(new ItemStack(ModItems.bronzeSword), new ItemStack(ModItems.bronzePickaxe),
				new ItemStack(ModItems.bronzeAxe), new ItemStack(ModItems.bronzeHoe),
				new ItemStack(ModItems.bronzeSpade), new ItemStack(ModItems.bronzeHelmet),
				new ItemStack(ModItems.bronzeChestplate), new ItemStack(ModItems.bronzeLeggings),
				new ItemStack(ModItems.bronzeBoots), ItemIngots.getIngotByName("bronze"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.ironChainsaw), " SS", "SCS", "BS ", 'S', "ingotSteel", 'B',
						TechRebornAPI.recipeCompact.getItem("reBattery"), 'C',
						TechRebornAPI.recipeCompact.getItem("electronicCircuit"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.diamondChainsaw), " SS", "SBS", "CS ", 'S', "ingotSteel",
						'B', ModItems.ironChainsaw, 'C', TechRebornAPI.recipeCompact.getItem("electronicCircuit"));

		CraftingHelper.addShapelessOreRecipe(ItemParts.getPartByName("carbonfiber"), ItemDusts.getDustByName("coal"),
				ItemDusts.getDustByName("coal"), ItemDusts.getDustByName("coal"), ItemDusts.getDustByName("coal"));

		CraftingHelper.addShapelessOreRecipe(ItemParts.getPartByName("carbonfiber"), ItemCells.getCellByName("carbon"),
				ItemCells.getCellByName("carbon"), ItemCells.getCellByName("carbon"), ItemCells.getCellByName("carbon"),
				ItemCells.getCellByName("carbon"), ItemCells.getCellByName("carbon"), ItemCells.getCellByName("carbon"),
				ItemCells.getCellByName("carbon"), ItemCells.getCellByName("carbon"));

		CraftingHelper
				.addShapelessOreRecipe(ItemParts.getPartByName("carbonmesh"), ItemParts.getPartByName("carbonfiber"),
						ItemParts.getPartByName("carbonfiber"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("computerMonitor"), "ADA", "DGD", "ADA", 'D', dyes, 'A',
						"ingotAluminum", 'G', Blocks.field_150410_aZ);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.reinforcedglass, 7), "GAG", "GGG", "GAG", 'A',
				ItemIngots.getIngotByName("advancedAlloy"), 'G', Blocks.field_150359_w);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.windMill, 2), "IXI", "XGX", "IXI", 'I', "ingotIron", 'G',
						ModBlocks.Generator);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.waterMill), "SWS", "WGW", "SWS", 'S', Items.field_151055_y, 'W',
						"plankWood", 'G', ModBlocks.Generator);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.hvt), "XHX", "XMX", "XHX", 'M', ModBlocks.mvt, 'H',
				ItemStandaloneCables.getCableByName("insulatedhv"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.mvt), "XGX", "XMX", "XGX", 'M',
				BlockMachineFrame.getFrameByName("machine", 1), 'G',
				ItemStandaloneCables.getCableByName("insulatedgold"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.lvt), "PWP", "CCC", "PPP", 'P', "plankWood", 'C',
				"ingotCopper", 'W', ItemStandaloneCables.getCableByName("insulatedcopper"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.MachineCasing, 4, 0), "RRR", "CAC", "RRR", 'R',
				ItemIngots.getIngotByName("refinedIron"), 'C', ItemParts.getPartByName("electronicCircuit"), 'A',
				BlockMachineFrame.getFrameByName("machine", 1));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.MachineCasing, 4, 1), "RRR", "CAC", "RRR", 'R',
				"ingotSteel", 'C', ItemParts.getPartByName("advancedCircuit"), 'A',
				BlockMachineFrame.getFrameByName("advancedMachine", 1));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("dataOrb"), "DDD", "DID", "DDD", 'D',
				ItemParts.getPartByName("dataStorageCircuit"), 'I', ItemParts.getPartByName("dataControlCircuit"));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("dataControlCircuit", 4), "CDC", "DID", "CDC", 'I',
				ItemPlates.getPlateByName("iridium"), 'D', ItemParts.getPartByName("dataStorageCircuit"), 'C',
				ItemParts.getPartByName("advancedCircuit"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.thermalGenerator), "III", "IRI", "CGC", 'I',
				"ingotInvar", 'R', ModBlocks.reinforcedglass, 'G', ModBlocks.Generator, 'C',
				ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.recycler), "XEX", "DCD", "GDG", 'D', Blocks.field_150346_d, 'C',
				ModBlocks.Compressor, 'G', Items.field_151114_aO, 'E', ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.batBox), "WCW", "BBB", "WWW", 'W', "plankWood", 'B',
				batteryStack, 'C', ItemStandaloneCables.getCableByName("insulatedcopper"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.mfe), "GEG", "EME", "GEG", 'M',
				BlockMachineFrame.getFrameByName("machine", 1), 'E', crystalStack, 'G',
				ItemStandaloneCables.getCableByName("insulatedgold"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.mfsu), "LAL", "LML", "LOL", 'A',
				ItemParts.getPartByName("advancedCircuit"), 'L', lapcrystalStack, 'M', new ItemStack(ModBlocks.mfe),
				'O', BlockMachineFrame.getFrameByName("advancedMachine", 1));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.IndustrialElectrolyzer), "RER", "CEC", "RER", 'R',
				ItemIngots.getIngotByName("refinediron"), 'E', new ItemStack(ModBlocks.Extractor), 'C',
				ItemParts.getPartByName("advancedCircuit"));

		// Mixed Metal Ingot Recipes :P

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 2), "RRR", "BBB", "TTT", 'R',
				"ingotRefinedIron", 'B', "ingotBronze", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 2), "RRR", "BBB", "TTT", 'R',
				"ingotRefinedIron", 'B', "ingotBronze", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 2), "RRR", "BBB", "TTT", 'R',
				"ingotRefinedIron", 'B', "ingotBrass", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 2), "RRR", "BBB", "TTT", 'R',
				"ingotRefinedIron", 'B', "ingotBrass", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 3), "RRR", "BBB", "TTT", 'R',
				"ingotNickel", 'B', "ingotBronze", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 3), "RRR", "BBB", "TTT", 'R',
				"ingotNickel", 'B', "ingotBronze", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 3), "RRR", "BBB", "TTT", 'R',
				"ingotNickel", 'B', "ingotBrass", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 3), "RRR", "BBB", "TTT", 'R',
				"ingotNickel", 'B', "ingotBrass", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 4), "RRR", "BBB", "TTT", 'R',
				"ingotNickel", 'B', "ingotBronze", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 4), "RRR", "BBB", "TTT", 'R',
				"ingotNickel", 'B', "ingotBrass", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 4), "RRR", "BBB", "TTT", 'R',
				"ingotInvar", 'B', "ingotBronze", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 4), "RRR", "BBB", "TTT", 'R',
				"ingotInvar", 'B', "ingotBronze", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 4), "RRR", "BBB", "TTT", 'R',
				"ingotInvar", 'B', "ingotBrass", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 4), "RRR", "BBB", "TTT", 'R',
				"ingotInvar", 'B', "ingotBrass", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotInvar", 'B', "ingotBronze", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotInvar", 'B', "ingotBrass", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTitanium", 'B', "ingotBronze", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTitanium", 'B', "ingotBronze", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTitanium", 'B', "ingotBrass", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTitanium", 'B', "ingotBrass", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 6), "RRR", "BBB", "TTT", 'R',
				"ingotTitanium", 'B', "ingotBronze", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 6), "RRR", "BBB", "TTT", 'R',
				"ingotTitanium", 'B', "ingotBrass", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTungsten", 'B', "ingotBronze", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTungsten", 'B', "ingotBronze", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTungsten", 'B', "ingotBrass", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 5), "RRR", "BBB", "TTT", 'R',
				"ingotTungsten", 'B', "ingotBrass", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 6), "RRR", "BBB", "TTT", 'R',
				"ingotTungsten", 'B', "ingotBronze", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 6), "RRR", "BBB", "TTT", 'R',
				"ingotTungsten", 'B', "ingotBrass", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 8), "RRR", "BBB", "TTT", 'R',
				"ingotTungstensteel", 'B', "ingotBronze", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 8), "RRR", "BBB", "TTT", 'R',
				"ingotTungstensteel", 'B', "ingotBronze", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 8), "RRR", "BBB", "TTT", 'R',
				"ingotTungstensteel", 'B', "ingotBrass", 'T', "ingotTin");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 8), "RRR", "BBB", "TTT", 'R',
				"ingotTungstensteel", 'B', "ingotBrass", 'T', "ingotZinc");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 9), "RRR", "BBB", "TTT", 'R',
				"ingotTungstensteel", 'B', "ingotBronze", 'T', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("mixedmetal", 9), "RRR", "BBB", "TTT", 'R',
				"ingotTungstensteel", 'B', "ingotBrass", 'T', "ingotAluminum");

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.Compressor), "SXS", "SCS", "SMS", 'C', "circuitBasic", 'M',
						BlockMachineFrame.getFrameByName("machine", 1), 'S', Blocks.field_150348_b);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.ElectricFurnace), "XCX", "RFR", "XXX", 'C', "circuitBasic",
						'F', new ItemStack(ModBlocks.ironFurnace), 'R', Items.field_151137_ax);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.ironFurnace), "III", "IXI", "III", 'I', "ingotIron");

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.ironFurnace), "XIX", "IXI", "IFI", 'I', "ingotIron", 'F',
						Blocks.field_150460_al);

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("electronicCircuit"), "WWW", "SRS", "WWW", 'R',
				"ingotRefinedIron", 'S', Items.field_151137_ax, 'W', ItemStandaloneCables.getCableByName("insulatedcopper"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.reBattery), "XWX", "TRT", "TRT", 'T', "ingotTin", 'R',
				Items.field_151137_ax, 'W', ItemStandaloneCables.getCableByName("insulatedcopper"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.wrench), "BAB", "BBB", "ABA", 'B', "ingotBronze");

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.Extractor), "TMT", "TCT", "XXX", 'T', ModItems.treeTap, 'M',
						BlockMachineFrame.getFrameByName("machine", 1), 'C',
						ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.centrifuge), "RCR", "AEA", "RCR", 'R', "ingotRefinedIron",
						'E', new ItemStack(ModBlocks.Extractor), 'A', "machineBlockAdvanced", 'C', "circuitBasic");

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("advancedCircuit"), "RGR", "LCL", "RGR", 'R',
				Items.field_151137_ax, 'G', Items.field_151114_aO, 'L', "dyeBlue", 'C',
				ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.energyCrystal), "RRR", "RDR", "RRR", 'R', Items.field_151137_ax,
						'D', Items.field_151045_i);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.lapotronCrystal), "LCL", "LEL", "LCL", 'L', "dyeBlue", 'E',
						new ItemStack(ModItems.energyCrystal), 'C', ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper.addShapelessOreRecipe(new ItemStack(ModBlocks.Generator), batteryStack,
				BlockMachineFrame.getFrameByName("machine", 1), Blocks.field_150460_al);

		CraftingHelper.addShapedOreRecipe(BlockMachineFrame.getFrameByName("machine", 1), "AAA", "AXA", "AAA", 'A',
				ItemIngots.getIngotByName("refinediron"));

		CraftingHelper
				.addShapedOreRecipe(BlockMachineFrame.getFrameByName("advancedMachine", 1), "XCX", "AMA", "XCX", 'A',
						ItemIngots.getIngotByName("advancedAlloy"), 'C', ItemPlates.getPlateByName("carbon"), 'M',
						BlockMachineFrame.getFrameByName("machine", 1));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("dataStorageCircuit"), "EEE", "ECE", "EEE", 'E',
				new ItemStack(Items.field_151166_bC), 'C', ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.parts, 4, 8), "DSD", "S S", "DSD", 'D', "dustDiamond", 'S',
						"ingotSteel");

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.parts, 1, 15), "AAA", "AMA", "AAA", 'A', "ingotAluminium",
						'M', new ItemStack(ModItems.parts, 1, 13));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Supercondensator), "EOE", "SAS", "EOE", 'E',
				ItemParts.getPartByName("energyFlowCircuit"), 'O', ModItems.lapotronicOrb, 'S',
				ItemParts.getPartByName("superconductor"), 'A',
				BlockMachineFrame.getFrameByName("highlyAdvancedMachine", 1));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("diamondSawBlade"), "DSD", "S S", "DSD", 'S', "plateSteel",
						'D', "dustDiamond");

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("wolframiumGrindingHead", 2), "TST", "SBS", "TST", 'T',
						"plateTungsten", 'S', "plateSteel", 'B', "blockSteel");

		/* TODO: Make destructopack seperate item
		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("destructoPack"), "CIC", "IBI", "CIC", 'C',
				ItemParts.getPartByName("advancedCircuit"), 'I', "ingotAluminum", 'B',
				new ItemStack(Items.lava_bucket));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("destructoPack"), "CIC", "IBI", "CIC", 'C',
				ItemParts.getPartByName("advancedCircuit"), 'I', "ingotRefinedIron", 'B',
				new ItemStack(Items.lava_bucket));
		*/

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.cloakingDevice), "CIC", "IOI", "CIC", 'C', "ingotChrome",
						'I', "plateIridium", 'O', new ItemStack(ModItems.lapotronicOrb));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.treeTap), " S ", "PPP", "P  ", 'S', "stickWood", 'P',
				"plankWood");

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.rockCutter), "DT ", "DT ", "DCB", 'D', "dustDiamond", 'T',
						"ingotTitanium", 'C', ItemParts.getPartByName("electronicCircuit"), 'B', batteryStack);

		for (String part : ItemParts.types)
		{
			if (part.endsWith("Gear"))
			{
				CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName(part), " O ", "OIO", " O ", 'I',
						new ItemStack(Items.field_151042_j), 'O',
						"ingot" + StringUtils.toFirstCapital(part.replace("Gear", "")));
			}
		}

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("nichromeHeatingCoil"), " N ", "NCN", " N ", 'N',
				"ingotNickel", 'C', "ingotChrome");

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("kanthalHeatingCoil"), "III", "CAA", "AAA", 'I',
				"ingotSteel", 'C', "ingotChrome", 'A', "ingotAluminum");

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("heliumCoolantSimple"), " T ", "TCT", " T ", 'T',
				"ingotTin", 'C', ItemCells.getCellByName("helium", 1, false));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("HeliumCoolantTriple"), "TTT", "CCC", "TTT", 'T',
				"ingotTin", 'C', ItemParts.getPartByName("heliumCoolantSimple"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("HeliumCoolantSix"), "THT", "TCT", "THT", 'T', "ingotTin",
						'C', "ingotCopper", 'H', ItemParts.getPartByName("HeliumCoolantTriple"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("NaKCoolantTriple"), "TTT", "CCC", "TTT", 'T', "ingotTin",
						'C', ItemParts.getPartByName("NaKCoolantSimple"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("NaKCoolantSix"), "THT", "TCT", "THT", 'T', "ingotTin", 'C',
						"ingotCopper", 'H', ItemParts.getPartByName("NaKCoolantTriple"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Aesu), "LLL", "LCL", "LLL", 'L',
				new ItemStack(ModItems.lapotronicOrb), 'C', new ItemStack(ModBlocks.ComputerCube));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Idsu), "PAP", "ACA", "PAP", 'P',
				ItemPlates.getPlateByName("iridium"), 'C', new ItemStack(Blocks.field_150477_bB), 'A',
				new ItemStack(ModBlocks.Aesu));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.FusionControlComputer), "CCC", "PTP", "CCC", 'P',
				new ItemStack(ModBlocks.ComputerCube), 'T', new ItemStack(ModBlocks.FusionCoil), 'C',
				ItemParts.getPartByName("energyFlowCircuit"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.LightningRod), "CAC", "ACA", "CAC", 'A',
				new ItemStack(ModBlocks.MachineCasing, 1, 2), 'S', ItemParts.getPartByName("superConductor"), 'C',
				ItemParts.getPartByName("energyFlowCircuit"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.FusionCoil), "CSC", "NAN", "CRC", 'A',
				new ItemStack(ModBlocks.MachineCasing, 1, 2), 'N', ItemParts.getPartByName("nichromeHeatingCoil"), 'C',
				ItemParts.getPartByName("energyFlowCircuit"), 'S', ItemParts.getPartByName("superConductor"), 'R',
				ItemParts.getPartByName("iridiumNeutronReflector"));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("iridiumNeutronReflector"), "PPP", "PIP", "PPP", 'P',
				ItemParts.getPartByName("thickNeutronReflector"), 'I', "ingotIridium");

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("thickNeutronReflector"), " P ", "PCP", " P ", 'P',
				ItemParts.getPartByName("neutronReflector"), 'C', ItemCells.getCellByName("Berylium"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("neutronReflector"), "TCT", "CPC", "TCT", 'T', "dustTin",
						'C', "dustCoal", 'P', "plateCopper");

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.scrapBox), "SSS", "SSS", "SSS", 'S',
				ItemParts.getPartByName("scrap"));

		CraftingHelper.addShapedOreRecipe(ItemUpgrades.getUpgradeByName("Overclock"), "TTT", "WCW", 'T',
				ItemParts.getPartByName("CoolantSimple"), 'W', ItemStandaloneCables.getCableByName("insulatedcopper"),
				'C', ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(ItemUpgrades.getUpgradeByName("Overclock", 2), " T ", "WCW", 'T',
				ItemParts.getPartByName("heliumCoolantSimple"), 'W',
				ItemStandaloneCables.getCableByName("insulatedcopper"), 'C',
				ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(ItemUpgrades.getUpgradeByName("Overclock", 2), " T ", "WCW", 'T',
				ItemParts.getPartByName("NaKCoolantSimple"), 'W',
				ItemStandaloneCables.getCableByName("insulatedcopper"), 'C',
				ItemParts.getPartByName("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(ItemUpgrades.getUpgradeByName("Transformer"), "GGG", "WTW", "GCG", 'G',
				"blockGlass", 'W', ItemStandaloneCables.getCableByName("insulatedgold"), 'C',
				ItemParts.getPartByName("electronicCircuit"), 'T', ModBlocks.mvt);

		CraftingHelper.addShapedOreRecipe(ItemUpgrades.getUpgradeByName("EnergyStorage"), "PPP", "WBW", "PCP", 'P',
				"plankWood", 'W', ItemStandaloneCables.getCableByName("insulatedcopper"), 'C',
				ItemParts.getPartByName("electronicCircuit"), 'B', ModItems.reBattery);

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("CoolantSimple"), " T ", "TWT", " T ", 'T', "ingotTin", 'W',
						"containerWater");

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("CoolantTriple"), "TTT", "CCC", "TTT", 'T', "ingotTin", 'C',
						ItemParts.getPartByName("CoolantSimple"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("CoolantSix"), "TCT", "TPT", "TCT", 'T', "ingotTin", 'C',
						ItemParts.getPartByName("CoolantTriple"), 'P', ItemPlates.getPlateByName("copper"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("NaKCoolantSimple"), "TST", "PCP", "TST", 'T', "ingotTin",
						'C', ItemParts.getPartByName("CoolantSimple"), 'S', ItemCells.getCellByName("sodium"), 'P',
						ItemCells.getCellByName("potassium"));

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("NaKCoolantSimple"), "TPT", "SCS", "TPT", 'T', "ingotTin",
						'C', ItemParts.getPartByName("CoolantSimple"), 'S', ItemCells.getCellByName("sodium"), 'P',
						ItemCells.getCellByName("potassium"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.advancedDrill), "ODO", "AOA", 'O', ItemUpgrades.getUpgradeByName("Overclock"),
						'D', diamondDrillStack, 'A', "circuitAdvanced");
		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.advancedChainsaw), "ODO", "AOA", 'O', ItemUpgrades.getUpgradeByName("Overclock"),
						'D', diamondChainsawStack, 'A', "circuitAdvanced");

		Core.logHelper.info("Shapped Recipes Added");
	}

	static void addShapelessRecipes()
	{
		for (String name : ArrayUtils.addAll(BlockStorage.types, BlockStorage2.types))
		{
			ItemStack item = null;
			try
			{
				item = ItemIngots.getIngotByName(name, 9);
			} catch (InvalidParameterException e)
			{
				try
				{
					item = ItemGems.getGemByName(name, 9);
				} catch (InvalidParameterException e2)
				{
					continue;
				}
			}

			if (item == null)
			{
				continue;
			}

			GameRegistry
					.addShapelessRecipe(BlockStorage.getStorageBlockByName(name), item, item, item, item, item, item,
							item, item, item);
			GameRegistry.addShapelessRecipe(item, BlockStorage.getStorageBlockByName(name, 9));
		}

		GameRegistry.addShapelessRecipe(new ItemStack(ModBlocks.rubberPlanks, 4), ModBlocks.rubberLog);
		GameRegistry.addShapelessRecipe(new ItemStack(ModItems.frequencyTransmitter),
				ItemStandaloneCables.getCableByName("insulatedcopper"), ItemParts.getPartByName("electronicCircuit"));

		for (String name : ItemDustsSmall.types)
		{
			GameRegistry.addShapelessRecipe(ItemDustsSmall.getSmallDustByName(name, 4), ItemDusts.getDustByName(name));
			GameRegistry.addShapelessRecipe(ItemDusts.getDustByName(name, 1), ItemDustsSmall.getSmallDustByName(name),
					ItemDustsSmall.getSmallDustByName(name), ItemDustsSmall.getSmallDustByName(name),
					ItemDustsSmall.getSmallDustByName(name));
		}

		Core.logHelper.info("Shapeless Recipes Added");
	}

	static void addMachineRecipes()
	{
		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.quantumTank), "EPE", "PCP", "EPE", 'P', "ingotPlatinum",
						'E', ItemParts.getPartByName("advancedCircuit"), 'C', ModBlocks.quantumChest);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.digitalChest), "PPP", "PDP", "PCP", 'P', "plateAluminum",
						'D', ItemParts.getPartByName("dataOrb"), 'C', ItemParts.getPartByName("computerMonitor"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.digitalChest), "PPP", "PDP", "PCP", 'P', "plateSteel", 'D',
						ItemParts.getPartByName("dataOrb"), 'C', ItemParts.getPartByName("computerMonitor"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.AlloySmelter), "XCX", "FMF", "XXX", 'C',
				ItemParts.getPartByName("electronicCircuit"), 'F', new ItemStack(ModBlocks.ElectricFurnace), 'M',
				BlockMachineFrame.getFrameByName("machine", 1));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.LesuStorage), "LLL", "LCL", "LLL", 'L', "blockLapis", 'C',
						ItemParts.getPartByName("electronicCircuit"));

		TechRebornAPI
				.addRollingOreMachinceRecipe(ItemParts.getPartByName("cupronickelHeatingCoil"), "NCN", "C C", "NCN",
						'N', "ingotCupronickel", 'C', "ingotCopper");

		RecipeHandler.addRecipe(new VacuumFreezerRecipe(ItemIngots.getIngotByName("hotTungstensteel"),
				ItemIngots.getIngotByName("tungstensteel"), 440, 128));
		RecipeHandler.addRecipe(
				new VacuumFreezerRecipe(ItemCells.getCellByName("water"), ItemCells.getCellByName("cell"), 60, 128));
	}

	static void addSmeltingRecipes()
	{
		GameRegistry.addSmelting(ItemDusts.getDustByName("iron", 1), new ItemStack(Items.field_151042_j), 1F);
		GameRegistry.addSmelting(ItemDusts.getDustByName("gold", 1), new ItemStack(Items.field_151043_k), 1F);
		GameRegistry.addSmelting(ItemParts.getPartByName("rubberSap"), ItemParts.getPartByName("rubber"), 1F);
		GameRegistry.addSmelting(new ItemStack(Items.field_151042_j), ItemIngots.getIngotByName("refinediron"), 1F);
		GameRegistry.addSmelting(BlockOre2.getOreByName("copper"), ItemIngots.getIngotByName("copper"), 1F);
		GameRegistry.addSmelting(BlockOre2.getOreByName("tin"), ItemIngots.getIngotByName("tin"), 1F);
		GameRegistry.addSmelting(BlockOre.getOreByName("Silver"), ItemIngots.getIngotByName("silver"), 1F);
		GameRegistry.addSmelting(BlockOre.getOreByName("Lead"), ItemIngots.getIngotByName("lead"), 1F);
		Core.logHelper.info("Smelting Recipes Added");
	}

	static void addAlloySmelterRecipes()
	{

		// Bronze
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemIngots.getIngotByName("copper", 3), ItemIngots.getIngotByName("tin", 1),
						ItemIngots.getIngotByName("bronze", 4), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemIngots.getIngotByName("copper", 3), ItemDusts.getDustByName("tin", 1),
						ItemIngots.getIngotByName("bronze", 4), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemDusts.getDustByName("copper", 3), ItemIngots.getIngotByName("tin", 1),
						ItemIngots.getIngotByName("bronze", 4), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemDusts.getDustByName("copper", 3), ItemDusts.getDustByName("tin", 1),
						ItemIngots.getIngotByName("bronze", 4), 200, 16));

		// Electrum
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(new ItemStack(Items.field_151043_k, 1), ItemIngots.getIngotByName("silver", 1),
						ItemIngots.getIngotByName("electrum", 2), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(new ItemStack(Items.field_151043_k, 1), ItemDusts.getDustByName("silver", 1),
						ItemIngots.getIngotByName("electrum", 2), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemDusts.getDustByName("gold", 1), ItemIngots.getIngotByName("silver", 1),
						ItemIngots.getIngotByName("electrum", 2), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemDusts.getDustByName("gold", 1), ItemDusts.getDustByName("silver", 1),
						ItemIngots.getIngotByName("electrum", 2), 200, 16));

		// Invar
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(new ItemStack(Items.field_151042_j, 2), ItemIngots.getIngotByName("nickel", 1),
						ItemIngots.getIngotByName("invar", 3), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(new ItemStack(Items.field_151042_j, 2), ItemDusts.getDustByName("nickel", 1),
						ItemIngots.getIngotByName("invar", 3), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemDusts.getDustByName("iron", 2), ItemIngots.getIngotByName("nickel", 1),
						ItemIngots.getIngotByName("invar", 3), 200, 16));
		RecipeHandler.addRecipe(
				new AlloySmelterRecipe(ItemDusts.getDustByName("iron", 2), ItemDusts.getDustByName("nickel", 1),
						ItemIngots.getIngotByName("invar", 3), 200, 16));

		// Brass
		if (OreUtil.doesOreExistAndValid("ingotBrass"))
		{
			ItemStack brassStack = OreDictionary.getOres("ingotBrass").get(0);
			brassStack.field_77994_a = 4;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemIngots.getIngotByName("copper", 3), ItemIngots.getIngotByName("zinc", 1),
							brassStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemIngots.getIngotByName("copper", 3), ItemDusts.getDustByName("zinc", 1),
							brassStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemDusts.getDustByName("copper", 3), ItemIngots.getIngotByName("zinc", 1),
							brassStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemDusts.getDustByName("copper", 3), ItemDusts.getDustByName("zinc", 1),
							brassStack, 200, 16));
		}

		// Red Alloy
		if (OreUtil.doesOreExistAndValid("ingotRedAlloy"))
		{
			ItemStack redAlloyStack = OreDictionary.getOres("ingotRedAlloy").get(0);
			redAlloyStack.field_77994_a = 1;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151137_ax, 4), ItemIngots.getIngotByName("copper", 1),
							redAlloyStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151137_ax, 4), new ItemStack(Items.field_151042_j, 1),
							redAlloyStack, 200, 16));
		}

		// Blue Alloy
		if (OreUtil.doesOreExistAndValid("ingotBlueAlloy"))
		{
			ItemStack blueAlloyStack = OreDictionary.getOres("ingotBlueAlloy").get(0);
			blueAlloyStack.field_77994_a = 1;
			RecipeHandler.addRecipe(new AlloySmelterRecipe(ItemDusts.getDustByName("teslatite", 4),
					ItemIngots.getIngotByName("silver", 1), blueAlloyStack, 200, 16));
		}

		// Blue Alloy
		if (OreUtil.doesOreExistAndValid("ingotPurpleAlloy") && OreUtil.doesOreExistAndValid("dustInfusedTeslatite"))
		{
			ItemStack purpleAlloyStack = OreDictionary.getOres("ingotPurpleAlloy").get(0);
			purpleAlloyStack.field_77994_a = 1;
			ItemStack infusedTeslatiteStack = OreDictionary.getOres("ingotPurpleAlloy").get(0);
			infusedTeslatiteStack.field_77994_a = 8;
			RecipeHandler.addRecipe(new AlloySmelterRecipe(ItemIngots.getIngotByName("redAlloy", 1),
					ItemIngots.getIngotByName("blueAlloy", 1), purpleAlloyStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151043_k, 1), infusedTeslatiteStack, purpleAlloyStack,
							200, 16));
		}

		// Aluminum Brass
		if (OreUtil.doesOreExistAndValid("ingotAluminumBrass"))
		{
			ItemStack aluminumBrassStack = OreDictionary.getOres("ingotAluminumBrass").get(0);
			aluminumBrassStack.field_77994_a = 4;
			RecipeHandler.addRecipe(new AlloySmelterRecipe(ItemIngots.getIngotByName("copper", 3),
					ItemIngots.getIngotByName("aluminum", 1), aluminumBrassStack, 200, 16));
			RecipeHandler.addRecipe(new AlloySmelterRecipe(ItemIngots.getIngotByName("copper", 3),
					ItemDusts.getDustByName("aluminum", 1), aluminumBrassStack, 200, 16));
			RecipeHandler.addRecipe(new AlloySmelterRecipe(ItemDusts.getDustByName("copper", 3),
					ItemIngots.getIngotByName("aluminum", 1), aluminumBrassStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemDusts.getDustByName("copper", 3), ItemDusts.getDustByName("aluminum", 1),
							aluminumBrassStack, 200, 16));
		}

		// Manyullyn
		if (OreUtil.doesOreExistAndValid("ingotManyullyn") && OreUtil.doesOreExistAndValid("ingotCobalt") && OreUtil
				.doesOreExistAndValid("ingotArdite"))
		{
			ItemStack manyullynStack = OreDictionary.getOres("ingotManyullyn").get(0);
			manyullynStack.field_77994_a = 1;
			ItemStack cobaltStack = OreDictionary.getOres("ingotCobalt").get(0);
			cobaltStack.field_77994_a = 1;
			ItemStack arditeStack = OreDictionary.getOres("ingotArdite").get(0);
			arditeStack.field_77994_a = 1;
			RecipeHandler.addRecipe(new AlloySmelterRecipe(cobaltStack, arditeStack, manyullynStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(cobaltStack, ItemDusts.getDustByName("ardite", 1), manyullynStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemDusts.getDustByName("cobalt", 1), arditeStack, manyullynStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(ItemDusts.getDustByName("cobalt", 1), ItemDusts.getDustByName("ardite", 1),
							manyullynStack, 200, 16));
		}

		// Conductive Iron
		if (OreUtil.doesOreExistAndValid("ingotConductiveIron"))
		{
			ItemStack conductiveIronStack = OreDictionary.getOres("ingotConductiveIron").get(0);
			conductiveIronStack.field_77994_a = 1;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151137_ax, 1), new ItemStack(Items.field_151042_j, 1),
							conductiveIronStack, 200, 16));
		}

		// Redstone Alloy
		if (OreUtil.doesOreExistAndValid("ingotRedstoneAlloy") && OreUtil.doesOreExistAndValid("itemSilicon"))
		{
			ItemStack redstoneAlloyStack = OreDictionary.getOres("ingotRedstoneAlloy").get(0);
			redstoneAlloyStack.field_77994_a = 1;
			ItemStack siliconStack = OreDictionary.getOres("itemSilicon").get(0);
			siliconStack.field_77994_a = 1;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151137_ax, 1), siliconStack, redstoneAlloyStack, 200,
							16));
		}

		// Pulsating Iron
		if (OreUtil.doesOreExistAndValid("ingotPhasedIron"))
		{
			ItemStack pulsatingIronStack = OreDictionary.getOres("ingotPhasedIron").get(0);
			pulsatingIronStack.field_77994_a = 1;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151042_j, 1), new ItemStack(Items.field_151079_bi, 1),
							pulsatingIronStack, 200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Items.field_151042_j, 1), ItemDusts.getDustByName("enderPearl", 1),
							pulsatingIronStack, 200, 16));
		}

		// Vibrant Alloy
		if (OreUtil.doesOreExistAndValid("ingotEnergeticAlloy") && OreUtil.doesOreExistAndValid("ingotPhasedGold"))
		{
			ItemStack energeticAlloyStack = OreDictionary.getOres("ingotEnergeticAlloy").get(0);
			energeticAlloyStack.field_77994_a = 1;
			ItemStack vibrantAlloyStack = OreDictionary.getOres("ingotPhasedGold").get(0);
			vibrantAlloyStack.field_77994_a = 1;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(energeticAlloyStack, new ItemStack(Items.field_151079_bi, 1), vibrantAlloyStack,
							200, 16));
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(energeticAlloyStack, ItemDusts.getDustByName("enderPearl", 1),
							vibrantAlloyStack, 200, 16));
		}

		// Soularium
		if (OreUtil.doesOreExistAndValid("ingotSoularium"))
		{
			ItemStack soulariumStack = OreDictionary.getOres("ingotSoularium").get(0);
			soulariumStack.field_77994_a = 1;
			RecipeHandler.addRecipe(
					new AlloySmelterRecipe(new ItemStack(Blocks.field_150425_aM, 1), new ItemStack(Items.field_151043_k, 1),
							soulariumStack, 200, 16));
		}

	}

	static void addPlateCuttingMachineRecipes()
	{

		for (String ore : OreUtil.oreNames)
		{
			if (OreUtil.hasBlock(ore) && OreUtil.hasPlate(ore))
			{
				RecipeHandler.addRecipe(
						new PlateCuttingMachineRecipe(OreUtil.getStackFromName("block" + StringUtils.toFirstCapital(ore)),
								OreUtil.getStackFromName("plate" + StringUtils.toFirstCapital(ore), 9), 200, 16));
			}
		}

		// Obsidian
		RecipeHandler.addRecipe(
				new PlateCuttingMachineRecipe(new ItemStack(Blocks.field_150343_Z), ItemPlates.getPlateByName("obsidian", 9),
						100, 4));
	}

	static void addIndustrialSawmillRecipes()
	{
		ItemStack pulpStack = OreDictionary.getOres("pulpWood").get(0);
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 0), null,
				new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Blocks.field_150344_f, 6, 0), pulpStack, null, 200, 30,
				false));
		RecipeHandler.addRecipe(
				new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 0), new ItemStack(Items.field_151131_as), null,
						new ItemStack(Blocks.field_150344_f, 6, 0), pulpStack, new ItemStack(Items.field_151133_ar), 200, 30, false));

		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 1), null,
				new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Blocks.field_150344_f, 6, 1), pulpStack, null, 200, 30,
				false));
		RecipeHandler.addRecipe(
				new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 1), new ItemStack(Items.field_151131_as), null,
						new ItemStack(Blocks.field_150344_f, 6, 1), pulpStack, new ItemStack(Items.field_151133_ar), 200, 30, false));

		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 2), null,
				new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Blocks.field_150344_f, 6, 2), pulpStack, null, 200, 30,
				false));
		RecipeHandler.addRecipe(
				new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 2), new ItemStack(Items.field_151131_as), null,
						new ItemStack(Blocks.field_150344_f, 6, 2), pulpStack, new ItemStack(Items.field_151133_ar), 200, 30, false));

		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 3), null,
				new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Blocks.field_150344_f, 6, 3), pulpStack, null, 200, 30,
				false));
		RecipeHandler.addRecipe(
				new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 3), new ItemStack(Items.field_151131_as), null,
						new ItemStack(Blocks.field_150344_f, 6, 3), pulpStack, new ItemStack(Items.field_151133_ar), 200, 30, false));

		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150363_s, 1, 0), null,
				new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Blocks.field_150344_f, 6, 4), pulpStack, null, 200, 30,
				false));
		RecipeHandler.addRecipe(
				new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150363_s, 1, 0), new ItemStack(Items.field_151131_as), null,
						new ItemStack(Blocks.field_150344_f, 6, 4), pulpStack, new ItemStack(Items.field_151133_ar), 200, 30, false));

		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150363_s, 1, 1), null,
				new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Blocks.field_150344_f, 6, 5), pulpStack, null, 200, 30,
				false));
		RecipeHandler.addRecipe(
				new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150363_s, 1, 1), new ItemStack(Items.field_151131_as), null,
						new ItemStack(Blocks.field_150344_f, 6, 5), pulpStack, new ItemStack(Items.field_151133_ar), 200, 30, false));
	}

	static void addBlastFurnaceRecipes()
	{
		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemDusts.getDustByName("titanium"), null, ItemIngots.getIngotByName("titanium"),
						null, 3600, 120, 1500));
		RecipeHandler.addRecipe(new BlastFurnaceRecipe(ItemDustsSmall.getSmallDustByName("titanium", 4), null,
				ItemIngots.getIngotByName("titanium"), null, 3600, 120, 1500));
		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemDusts.getDustByName("aluminum"), null, ItemIngots.getIngotByName("aluminum"),
						null, 2200, 120, 1700));
		RecipeHandler.addRecipe(new BlastFurnaceRecipe(ItemDustsSmall.getSmallDustByName("aluminum", 4), null,
				ItemIngots.getIngotByName("aluminum"), null, 2200, 120, 1700));
		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemDusts.getDustByName("tungsten"), null, ItemIngots.getIngotByName("tungsten"),
						null, 18000, 120, 2500));
		RecipeHandler.addRecipe(new BlastFurnaceRecipe(ItemDustsSmall.getSmallDustByName("tungsten", 4), null,
				ItemIngots.getIngotByName("tungsten"), null, 18000, 120, 2500));
		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemDusts.getDustByName("chrome"), null, ItemIngots.getIngotByName("chrome"),
						null, 4420, 120, 1700));
		RecipeHandler.addRecipe(new BlastFurnaceRecipe(ItemDustsSmall.getSmallDustByName("chrome", 4), null,
				ItemIngots.getIngotByName("chrome"), null, 4420, 120, 1700));
		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemDusts.getDustByName("steel"), null, ItemIngots.getIngotByName("steel"), null,
						2800, 120, 1000));
		RecipeHandler.addRecipe(new BlastFurnaceRecipe(ItemDustsSmall.getSmallDustByName("steel", 4), null,
				ItemIngots.getIngotByName("steel"), null, 2800, 120, 1000));

		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemDusts.getDustByName("galena", 2), null, ItemIngots.getIngotByName("silver"),
						ItemIngots.getIngotByName("lead"), 80, 120, 1500));

		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(new ItemStack(Items.field_151042_j), ItemDusts.getDustByName("coal", 2),
						ItemIngots.getIngotByName("steel"), ItemDusts.getDustByName("darkAshes", 2), 500, 120, 1000));

		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(ItemIngots.getIngotByName("tungsten"), ItemIngots.getIngotByName("steel"),
						ItemIngots.getIngotByName("hotTungstensteel"), ItemDusts.getDustByName("darkAshes", 4), 500,
						500, 3000));

		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(new ItemStack(Blocks.field_150366_p), ItemDusts.getDustByName("calcite"),
						new ItemStack(Items.field_151042_j, 3), ItemDusts.getDustByName("darkAshes"), 140, 120, 1000));

		RecipeHandler.addRecipe(
				new BlastFurnaceRecipe(BlockOre.getOreByName("Pyrite"), ItemDusts.getDustByName("calcite"),
						new ItemStack(Items.field_151042_j, 2), ItemDusts.getDustByName("darkAshes"), 140, 120, 1000));
	}

	static void addUUrecipes()
	{

		if (ConfigTechReborn.UUrecipesWood)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150364_r, 8), " U ", "   ", "   ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesStone)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150348_b, 16), "   ", " U ", "   ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesSnowBlock)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150433_aE, 16), "U U", "   ", "   ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesGrass)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150349_c, 16), "   ", "U  ", "U  ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesObsidian)
			CraftingHelper.addShapedOreRecipe(new ItemStack(Blocks.field_150343_Z, 12), "U U", "U U", "   ", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesGlass)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150359_w, 32), " U ", "U U", " U ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesCocoa)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151100_aR, 32, 3), "UU ", "  U", "UU ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesGlowstoneBlock)
			CraftingHelper.addShapedOreRecipe(new ItemStack(Blocks.field_150426_aN, 8), " U ", "U U", "UUU", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesCactus)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150434_aF, 48), " U ", "UUU", "U U", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesSugarCane)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151120_aE, 48), "U U", "U U", "U U", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesVine)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150395_bd, 24), "U  ", "U  ", "U  ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesSnowBall)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151126_ay, 16), "   ", "   ", "UUU", 'U', ModItems.uuMatter);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(Items.field_151119_aD, 48), "UU ", "U  ", "UU ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipeslilypad)
			CraftingHelper.addShapedOreRecipe(new ItemStack(Blocks.field_150392_bi, 64), "U U", " U ", " U ", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesGunpowder)
			CraftingHelper.addShapedOreRecipe(new ItemStack(Items.field_151016_H, 15), "UUU", "U  ", "UUU", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesBone)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151103_aS, 32), "U  ", "UU ", "U  ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesFeather)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151008_G, 32), " U ", " U ", "U U", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesInk)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151100_aR, 48), " UU", " UU", " U ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesEnderPearl)
			CraftingHelper.addShapedOreRecipe(new ItemStack(Items.field_151079_bi, 1), "UUU", "U U", " U ", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesCoal)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151044_h, 5), "  U", "U  ", "  U", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesIronOre)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150366_p, 2), "U U", " U ", "U U", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesGoldOre)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Blocks.field_150352_o, 2), " U ", "UUU", " U ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesRedStone)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151137_ax, 24), "   ", " U ", "UUU", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesLapis)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151100_aR, 9, 4), " U ", " U ", " UU", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesEmeraldOre)
			CraftingHelper.addShapedOreRecipe(new ItemStack(Blocks.field_150412_bA, 1), "UU ", "U U", " UU", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesEmerald)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151166_bC, 2), "UUU", "UUU", " U ", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesDiamond)
			CraftingHelper
					.addShapedOreRecipe(new ItemStack(Items.field_151045_i, 1), "UUU", "UUU", "UUU", 'U', ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesTinDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 10, 77), "   ", "U U", "  U", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesCopperDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 10, 21), "  U", "U U", "   ", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesLeadDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 14, 42), "UUU", "UUU", "U  ", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesPlatinumDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 1, 58), "  U", "UUU", "UUU", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesTungstenDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 1, 79), "U  ", "UUU", "UUU", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesTitaniumDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 2, 78), "UUU", " U ", " U ", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.UUrecipesAluminumDust)
			CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.dusts, 16, 2), " U ", " U ", "UUU", 'U',
					ModItems.uuMatter);

		if (ConfigTechReborn.HideUuRecipes)
			hideUUrecipes();

	}

	static void hideUUrecipes()
	{
		// TODO
	}

	static void addIndustrialCentrifugeRecipes()
	{

		// Mycelium Byproducts
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Blocks.field_150391_bh, 8), null, new ItemStack(Blocks.field_150338_P, 2),
						new ItemStack(Blocks.field_150337_Q, 2), new ItemStack(Items.field_151119_aD, 1),
						new ItemStack(Blocks.field_150354_m, 4), 1640, 5));

		// Blaze Powder Byproducts
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151065_br), null, ItemDusts.getDustByName("darkAshes", 1),
						ItemDusts.getDustByName("sulfur", 1), null, null, 1240, 5));

		// Magma Cream Products
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151064_bs, 1), null, new ItemStack(Items.field_151065_br, 1),
						new ItemStack(Items.field_151123_aH, 1), null, null, 2500, 5));

		// Dust Byproducts
		// RecipeHandler.addRecipe(new
		// CentrifugeRecipe(ItemDusts.getDustByName("platinum", 1), null,
		// ItemDustsTiny.getTinyDustByName("Iridium", 1),
		// ItemDustsSmall.getSmallDustByName("Nickel", 1), null, null, 3000,
		// 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("electrum", 2), null, ItemDusts.getDustByName("silver", 1),
						ItemDusts.getDustByName("gold", 1), null, null, 2400, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("invar", 3), null, ItemDusts.getDustByName("iron", 2),
						ItemDusts.getDustByName("nickel", 1), null, null, 1340, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(ItemDusts.getDustByName("marble", 8), null,
				ItemDusts.getDustByName("magnesium", 1), ItemDusts.getDustByName("calcite", 7), null, null, 1280, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("redrock", 4), null, ItemDusts.getDustByName("calcite", 2),
						ItemDusts.getDustByName("flint", 1), ItemDusts.getDustByName("clay", 1), null, 640, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("basalt", 16), null, ItemDusts.getDustByName("peridot", 1),
						ItemDusts.getDustByName("calcite", 3), ItemDusts.getDustByName("magnesium", 8),
						ItemDusts.getDustByName("darkAshes", 4), 2680, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(ItemDusts.getDustByName("yellowGarnet", 16), null,
				ItemDusts.getDustByName("andradite", 5), ItemDusts.getDustByName("grossular", 8),
				ItemDusts.getDustByName("uvarovite", 3), null, 2940, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(ItemDusts.getDustByName("redGarnet", 16), null,
				ItemDusts.getDustByName("pyrope", 3), ItemDusts.getDustByName("almandine", 5),
				ItemDusts.getDustByName("spessartine", 8), null, 2940, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("darkAshes", 2), null, ItemDusts.getDustByName("ashes", 2),
						null, null, null, 240, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("brass", 4), null, ItemDusts.getDustByName("zinc", 1),
						ItemDusts.getDustByName("copper", 3), null, null, 2000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("bronze", 4), null, ItemDusts.getDustByName("tin", 1),
						ItemDusts.getDustByName("copper", 3), null, null, 2420, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("netherrack", 16), null, new ItemStack(Items.field_151137_ax, 1),
						ItemDusts.getDustByName("sulfur", 4), ItemDusts.getDustByName("basalt", 1),
						new ItemStack(Items.field_151074_bl, 1), 2400, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(ItemDusts.getDustByName("enderEye", 1), null,
				ItemDusts.getDustByName("enderPearl", 1), new ItemStack(Items.field_151065_br, 1), null, null, 1280, 5));

		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151114_aO, 16), RecipeUtils.getEmptyCell(1),
						ItemCells.getCellByName("helium", 1, false), ItemDusts.getDustByName("gold", 8),
						new ItemStack(Items.field_151137_ax), null, 25000, 20));
	}

	static void addIndustrialGrinderRecipes()
	{
		for (String ore : OreUtil.oreNames)
		{
			if (OreUtil.hasIngot(ore) && OreUtil.hasDustSmall(ore) && OreUtil.hasBlock(ore))
			{
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(OreUtil.getStackFromName("block" + StringUtils.toFirstCapital(ore)),
								null, new FluidStack(FluidRegistry.WATER, 1000),
								OreUtil.getStackFromName("ingot" + StringUtils.toFirstCapital(ore)),
								OreUtil.getStackFromName("dustSmall" + StringUtils.toFirstCapital(ore), 6),
								OreUtil.getStackFromName("dustSmall" + StringUtils.toFirstCapital(ore), 2), null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(OreUtil.getStackFromName("block" + StringUtils.toFirstCapital(ore)),
								new ItemStack(Items.field_151131_as), null,
								OreUtil.getStackFromName("ingot" + StringUtils.toFirstCapital(ore)),
								OreUtil.getStackFromName("dustSmall" + StringUtils.toFirstCapital(ore), 6),
								OreUtil.getStackFromName("dustSmall" + StringUtils.toFirstCapital(ore), 2),
								new ItemStack(Items.field_151133_ar), 100, 120));
			}
		}

		// Copper Ore
		if (OreUtil.doesOreExistAndValid("oreCopper"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCopper").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								ItemDusts.getDustByName("copper", 2), ItemDustsSmall.getSmallDustByName("Gold", 1),
								ItemDustsSmall.getSmallDustByName("Nickel", 1), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("copper", 2), ItemDustsSmall.getSmallDustByName("Gold", 1),
						ItemDustsSmall.getSmallDustByName("Nickel", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, null,
						new FluidStack(ModFluids.fluidSodiumpersulfate, 1000), ItemDusts.getDustByName("copper", 2),
						ItemDusts.getDustByName("gold", 1), ItemDustsSmall.getSmallDustByName("Nickel", 1), null, 100,
						120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketSodiumpersulfate), null,
								ItemDusts.getDustByName("copper", 2), ItemDusts.getDustByName("gold", 1),
								ItemDustsSmall.getSmallDustByName("Nickel", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(ModFluids.fluidMercury, 1000),
								ItemDusts.getDustByName("copper", 2), ItemDustsSmall.getSmallDustByName("Gold", 1),
								ItemDusts.getDustByName("nickel", 1), null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("mercury", 1), null,
								ItemDusts.getDustByName("copper", 2), ItemDustsSmall.getSmallDustByName("Gold", 1),
								ItemDusts.getDustByName("nickel", 1), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Copper Ore");
			}
		}

		// Tin Ore
		if (OreUtil.doesOreExistAndValid("oreTin"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTin").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								ItemDusts.getDustByName("tin", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Zinc", 1), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("tin", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
						ItemDustsSmall.getSmallDustByName("Zinc", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, null,
						new FluidStack(ModFluids.fluidSodiumpersulfate, 1000), ItemDusts.getDustByName("tin", 2),
						ItemDustsSmall.getSmallDustByName("Iron", 1), ItemDusts.getDustByName("zinc", 1), null, 100,
						120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketSodiumpersulfate), null,
								ItemDusts.getDustByName("tin", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("zinc", 1), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Tin Ore");
			}
		}

		// Nickel Ore
		if (OreUtil.doesOreExistAndValid("oreNickel"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreNickel").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								ItemDusts.getDustByName("nickel", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Platinum", 1), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("nickel", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
						ItemDustsSmall.getSmallDustByName("Platinum", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, null,
						new FluidStack(ModFluids.fluidSodiumpersulfate, 1000), ItemDusts.getDustByName("nickel", 3),
						ItemDustsSmall.getSmallDustByName("Iron", 1), ItemDustsSmall.getSmallDustByName("Platinum", 1),
						null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketSodiumpersulfate), null,
								ItemDusts.getDustByName("nickel", 3), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Platinum", 1), new ItemStack(Items.field_151133_ar), 100,
								120));

				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(ModFluids.fluidMercury, 1000),
								ItemDusts.getDustByName("nickel", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("platinum", 1), null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketMercury), null,
								ItemDusts.getDustByName("nickel", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("platinum", 1), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Nickel Ore");
			}
		}

		// Zinc Ore
		if (OreUtil.doesOreExistAndValid("oreZinc"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreZinc").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								ItemDusts.getDustByName("zinc", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Tin", 1), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("zinc", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
						ItemDustsSmall.getSmallDustByName("Tin", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, null,
						new FluidStack(ModFluids.fluidSodiumpersulfate, 1000), ItemDusts.getDustByName("zinc", 2),
						ItemDustsSmall.getSmallDustByName("Iron", 1), ItemDusts.getDustByName("iron", 1), null, 100,
						120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketSodiumpersulfate), null,
								ItemDusts.getDustByName("zinc", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("iron", 1), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Zinc Ore");
			}
		}

		// Silver Ore
		if (OreUtil.doesOreExistAndValid("oreSilver"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreSilver").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								ItemDusts.getDustByName("silver", 2), ItemDustsSmall.getSmallDustByName("Lead", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("silver", 2), ItemDustsSmall.getSmallDustByName("Lead", 1),
						ItemDustsSmall.getSmallDustByName("Sulfur", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(ModFluids.fluidMercury, 1000),
								ItemDusts.getDustByName("silver", 3), ItemDustsSmall.getSmallDustByName("Lead", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketMercury), null,
								ItemDusts.getDustByName("silver", 3), ItemDustsSmall.getSmallDustByName("Lead", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Silver Ore");
			}
		}

		// Lead Ore
		if (OreUtil.doesOreExistAndValid("oreLead"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreLead").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								ItemDusts.getDustByName("lead", 2), ItemDustsSmall.getSmallDustByName("Silver", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("lead", 2), ItemDustsSmall.getSmallDustByName("Silver", 1),
						ItemDustsSmall.getSmallDustByName("Sulfur", 1), new ItemStack(Items.field_151133_ar), 100, 120));

				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(ModFluids.fluidMercury, 1000),
								ItemDusts.getDustByName("lead", 2), ItemDusts.getDustByName("silver", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(ModItems.bucketMercury), null,
								ItemDusts.getDustByName("lead", 2), ItemDusts.getDustByName("silver", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Lead Ore");
			}
		}

		// Apatite Ore
		if (OreUtil.doesOreExistAndValid("oreApatite") & OreUtil.doesOreExistAndValid("gemApatite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreApatite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemApatite").get(0);
				gemStack.field_77994_a = 6;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								gemStack, ItemDustsSmall.getSmallDustByName("Phosphorous", 4), null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								gemStack, ItemDustsSmall.getSmallDustByName("Phosphorous", 4),
								new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Apatite Ore");
			}
		}

		// Nether Quartz Ore
		if (OreUtil.doesOreExistAndValid("dustNetherQuartz"))
		{
			try
			{
				ItemStack dustStack = OreDictionary.getOres("dustNetherQuartz").get(0);
				dustStack.field_77994_a = 4;
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150449_bY, 1), null,
						new FluidStack(FluidRegistry.WATER, 1000), new ItemStack(Items.field_151128_bU, 2), dustStack,
						ItemDustsSmall.getSmallDustByName("Netherrack", 2), null, 100, 120));
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150449_bY, 1),
						new ItemStack(Items.field_151131_as), null, new ItemStack(Items.field_151128_bU, 2), dustStack,
						ItemDustsSmall.getSmallDustByName("Netherrack", 2), new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Nether Quartz Ore");
			}
		}

		// Certus Quartz Ore
		if (OreUtil.doesOreExistAndValid("oreCertusQuartz"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCertusQuartz").get(0);
				ItemStack gemStack = OreDictionary.getOres("crystalCertusQuartz").get(0);
				ItemStack dustStack = OreDictionary.getOres("dustCertusQuartz").get(0);
				dustStack.field_77994_a = 2;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								dustStack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								dustStack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Certus Quartz Ore");
			}
		}

		// Charged Certus Quartz Ore
		if (OreUtil.doesOreExistAndValid("oreChargedCertusQuartz"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreChargedCertusQuartz").get(0);
				ItemStack gemStack = OreDictionary.getOres("crystalChargedCertusQuartz").get(0);
				ItemStack dustStack = OreDictionary.getOres("dustCertusQuartz").get(0);
				dustStack.field_77994_a = 2;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								dustStack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								dustStack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Charged Certus Quartz Ore");
			}
		}

		// Amethyst Ore
		if (OreUtil.doesOreExistAndValid("oreAmethyst") && OreUtil.doesOreExistAndValid("gemAmethyst"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreAmethyst").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemAmethyst").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemAmethyst").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								dustStack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								dustStack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Certus Quartz Ore");
			}
		}

		// Topaz Ore
		if (OreUtil.doesOreExistAndValid("oreTopaz") && OreUtil.doesOreExistAndValid("gemTopaz"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTopaz").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemTopaz").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemTopaz").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								dustStack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								dustStack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Topaz Ore");
			}
		}

		// Tanzanite Ore
		if (OreUtil.doesOreExistAndValid("oreTanzanite") && OreUtil.doesOreExistAndValid("gemTanzanite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTanzanite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemTanzanite").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemTanzanite").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								dustStack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								dustStack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Tanzanite Ore");
			}
		}

		// Malachite Ore
		if (OreUtil.doesOreExistAndValid("oreMalachite") && OreUtil.doesOreExistAndValid("gemMalachite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreMalachite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemMalachite").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemMalachite").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000), gemStack,
								dustStack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, gemStack,
								dustStack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Malachite Ore");
			}
		}

		// Galena Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 0), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("galena", 2),
				ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemDustsSmall.getSmallDustByName("Silver", 1), null,
				100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 0), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("galena", 2), ItemDustsSmall.getSmallDustByName("Sulfur", 1),
						ItemDustsSmall.getSmallDustByName("Silver", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 0), null,
				new FluidStack(ModFluids.fluidMercury, 1000), ItemDusts.getDustByName("galena", 2),
				ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemDusts.getDustByName("silver", 1), null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 0), new ItemStack(ModItems.bucketMercury),
						null, ItemDusts.getDustByName("galena", 2), ItemDustsSmall.getSmallDustByName("Sulfur", 1),
						ItemDusts.getDustByName("silver", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		// Ruby Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 2), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemGems.getGemByName("ruby", 1),
				ItemDustsSmall.getSmallDustByName("Ruby", 6), ItemDustsSmall.getSmallDustByName("Chrome", 2), null, 100,
				120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 2), new ItemStack(Items.field_151131_as), null,
						ItemGems.getGemByName("ruby", 1), ItemDustsSmall.getSmallDustByName("Ruby", 6),
						ItemDustsSmall.getSmallDustByName("Chrome", 2), new ItemStack(Items.field_151133_ar), 100, 120));

		// Sapphire Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 3), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemGems.getGemByName("sapphire", 1),
				ItemDustsSmall.getSmallDustByName("Sapphire", 6), ItemDustsSmall.getSmallDustByName("Aluminum", 2),
				null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 3), new ItemStack(Items.field_151131_as), null,
						ItemGems.getGemByName("sapphire", 1), ItemDustsSmall.getSmallDustByName("Sapphire", 6),
						ItemDustsSmall.getSmallDustByName("Aluminum", 2), new ItemStack(Items.field_151133_ar), 100, 120));

		// Bauxite Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 4), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("bauxite", 2),
				ItemDustsSmall.getSmallDustByName("Grossular", 4), ItemDustsSmall.getSmallDustByName("Titanium", 4),
				null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 4), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("bauxite", 2), ItemDustsSmall.getSmallDustByName("Grossular", 4),
						ItemDustsSmall.getSmallDustByName("Titanium", 4), new ItemStack(Items.field_151133_ar), 100, 120));

		// Pyrite Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 5), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("pyrite", 2),
				ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemDustsSmall.getSmallDustByName("Phosphorous", 1),
				null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 5), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("pyrite", 2), ItemDustsSmall.getSmallDustByName("Sulfur", 1),
						ItemDustsSmall.getSmallDustByName("Phosphorous", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		// Cinnabar Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 6), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("cinnabar", 2),
				ItemDustsSmall.getSmallDustByName("Redstone", 1), ItemDustsSmall.getSmallDustByName("Glowstone", 1),
				null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 6), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("cinnabar", 2), ItemDustsSmall.getSmallDustByName("Redstone", 1),
						ItemDustsSmall.getSmallDustByName("Glowstone", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		// Sphalerite Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 7), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("sphalerite", 2),
				ItemDustsSmall.getSmallDustByName("Zinc", 1), ItemDustsSmall.getSmallDustByName("YellowGarnet", 1),
				null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 7), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("sphalerite", 2), ItemDustsSmall.getSmallDustByName("Zinc", 1),
						ItemDustsSmall.getSmallDustByName("YellowGarnet", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 7), null,
				new FluidStack(ModFluids.fluidSodiumpersulfate, 1000), ItemDusts.getDustByName("sphalerite", 2),
				ItemDusts.getDustByName("zinc", 1), ItemDustsSmall.getSmallDustByName("YellowGarnet", 1), null, 100,
				120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 7),
				new ItemStack(ModItems.bucketSodiumpersulfate), null, ItemDusts.getDustByName("sphalerite", 2),
				ItemDusts.getDustByName("zinc", 1), ItemDustsSmall.getSmallDustByName("YellowGarnet", 1),
				new ItemStack(Items.field_151133_ar), 100, 120));

		// Tungsten Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 8), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("tungsten", 2),
				ItemDustsSmall.getSmallDustByName("Manganese", 1), ItemDustsSmall.getSmallDustByName("Silver", 1), null,
				100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 8), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("tungsten", 2), ItemDustsSmall.getSmallDustByName("Manganese", 1),
						ItemDustsSmall.getSmallDustByName("Silver", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 8), null,
				new FluidStack(ModFluids.fluidMercury, 1000), ItemDusts.getDustByName("tungsten", 2),
				ItemDustsSmall.getSmallDustByName("Manganese", 1), ItemDusts.getDustByName("silver", 2), null, 100,
				120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 8), new ItemStack(ModItems.bucketMercury),
						null, ItemDusts.getDustByName("tungsten", 2), ItemDustsSmall.getSmallDustByName("Manganese", 1),
						ItemDusts.getDustByName("silver", 2), new ItemStack(Items.field_151133_ar), 100, 120));

		// Sheldonite Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 9), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("platinum", 2),
				ItemNuggets.getNuggetByName("iridium", 2), ItemDusts.getDustByName("nickel", 1), null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 9), new ItemStack(Items.field_151131_as), null,
						ItemDusts.getDustByName("platinum", 2), ItemNuggets.getNuggetByName("iridium", 2),
						ItemDusts.getDustByName("nickel", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 9), null,
				new FluidStack(ModFluids.fluidMercury, 1000), ItemDusts.getDustByName("platinum", 3),
				ItemNuggets.getNuggetByName("iridium", 2), ItemDusts.getDustByName("nickel", 1), null, 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 9), new ItemStack(ModItems.bucketMercury),
						null, ItemDusts.getDustByName("platinum", 3), ItemNuggets.getNuggetByName("iridium", 2),
						ItemDusts.getDustByName("nickel", 1), new ItemStack(Items.field_151133_ar), 100, 120));

		// Peridot Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 10), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemGems.getGemByName("peridot", 1),
				ItemDustsSmall.getSmallDustByName("Peridot", 6), ItemDustsSmall.getSmallDustByName("Pyrope", 2), null,
				100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 10), new ItemStack(Items.field_151131_as),
						null, ItemGems.getGemByName("peridot", 1), ItemDustsSmall.getSmallDustByName("Peridot", 6),
						ItemDustsSmall.getSmallDustByName("Pyrope", 2), new ItemStack(Items.field_151133_ar), 100, 120));

		// Sodalite Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 11), null,
				new FluidStack(FluidRegistry.WATER, 1000), ItemDusts.getDustByName("sodalite", 12),
				ItemDusts.getDustByName("aluminum", 3), null, null,
				100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 11), new ItemStack(Items.field_151131_as),
						null, ItemDusts.getDustByName("sodalite", 12), ItemDusts.getDustByName("aluminum", 3), null, new ItemStack(Items.field_151133_ar), 100, 120));
	}

	static void addImplosionCompressorRecipes()
	{
	}

	static void addChemicalReactorRecipes()
	{
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(ItemCells.getCellByName("calcium", 1), ItemCells.getCellByName("carbon", 1),
						ItemCells.getCellByName("calciumCarbonate", 2), 240, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(new ItemStack(Items.field_151074_bl, 8), new ItemStack(Items.field_151127_ba, 1),
						new ItemStack(Items.field_151060_bw, 1), 40, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(ItemCells.getCellByName("nitrogen", 1), ItemCells.getCellByName("carbon", 1),
						ItemCells.getCellByName("nitrocarbon", 2), 1500, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(ItemCells.getCellByName("carbon", 1), ItemCells.getCellByName("hydrogen", 4),
						ItemCells.getCellByName("methane", 5), 3500, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(ItemCells.getCellByName("sulfur", 1), ItemCells.getCellByName("sodium", 1),
						ItemCells.getCellByName("sodiumSulfide", 2), 100, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(new ItemStack(Items.field_151065_br, 1), new ItemStack(Items.field_151079_bi, 1),
						new ItemStack(Items.field_151061_bv, 1), 40, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(new ItemStack(Items.field_151074_bl, 8), new ItemStack(Items.field_151172_bF, 1),
						new ItemStack(Items.field_151150_bK, 1), 40, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(ItemCells.getCellByName("glyceryl", 1), ItemCells.getCellByName("diesel", 4),
						ItemCells.getCellByName("nitroDiesel", 5), 1000, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(new ItemStack(Items.field_151043_k, 8), new ItemStack(Items.field_151034_e, 1),
						new ItemStack(Items.field_151153_ao, 1), 40, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(new ItemStack(Blocks.field_150340_R, 8), new ItemStack(Items.field_151034_e, 1),
						new ItemStack(Items.field_151153_ao, 1, 1), 40, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(new ItemStack(Items.field_151065_br, 1), new ItemStack(Items.field_151123_aH, 1),
						new ItemStack(Items.field_151064_bs, 1), 40, 30));
	}

	static void addIndustrialElectrolyzerRecipes()
	{

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("nitrocarbon", 2), null,
				ItemCells.getCellByName("nitrogen"), ItemCells.getCellByName("carbon"), null, null, 80, 60));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("pyrite", 3), null,
				ItemDusts.getDustByName("iron"), ItemDusts.getDustByName("sulfur"), null, null, 120, 128));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("sphalerite", 2), null,
				ItemDusts.getDustByName("zinc"), ItemDusts.getDustByName("sulfur"), null, null, 150, 100));

	}

	static void addIc2Recipes()
	{
		CraftingHelper.addShapelessOreRecipe(new ItemStack(ModItems.manual), ItemIngots.getIngotByName("refinedIron"),
				Items.field_151122_aG);

		CraftingHelper
				.addShapedOreRecipe(ItemParts.getPartByName("machineParts", 16), "CSC", "SCS", "CSC", 'S', "ingotSteel",
						'C', TechRebornAPI.recipeCompact.getItem("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("energyFlowCircuit", 4), "ATA", "LIL", "ATA", 'T',
				"ingotTungsten", 'I', "plateIridium", 'A', TechRebornAPI.recipeCompact.getItem("advancedCircuit"), 'L',
				TechRebornAPI.recipeCompact.getItem("lapotronCrystal"));

		CraftingHelper.addShapedOreRecipe(ItemParts.getPartByName("superconductor", 4), "CCC", "TIT", "EEE", 'E',
				ItemParts.getPartByName("energyFlowCircuit"), 'C', ItemParts.getPartByName("heliumCoolantSimple"), 'T',
				"ingotTungsten", 'I', TechRebornAPI.recipeCompact.getItem("iridiumPlate"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModItems.lapotronicOrb), "LLL", "LPL", "LLL", 'L',
				new ItemStack(TechRebornAPI.recipeCompact.getItem("lapotronCrystal").func_77973_b(), 1,
						OreDictionary.WILDCARD_VALUE), 'P', TechRebornAPI.recipeCompact.getItem("iridiumPlate"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.industrialSawmill), "PAP", "SSS", "ACA", 'P',
				ItemIngots.getIngotByName("refinedIron"), 'A', TechRebornAPI.recipeCompact.getItem("advancedCircuit"),
				'S', ItemParts.getPartByName("diamondSawBlade"), 'C',
				TechRebornAPI.recipeCompact.getItem("advancedMachine"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.ComputerCube), "DME", "MAM", "EMD", 'E',
				ItemParts.getPartByName("energyFlowCircuit"), 'D', ItemParts.getPartByName("dataOrb"), 'M',
				ItemParts.getPartByName("computerMonitor"), 'A',
				TechRebornAPI.recipeCompact.getItem("advancedMachine"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.MatterFabricator), "ETE", "AOA", "ETE", 'E',
				ItemParts.getPartByName("energyFlowCircuit"), 'T', ModBlocks.Extractor, 'A',
				BlockMachineFrame.getFrameByName("highlyAdvancedMachine", 1), 'O', ModItems.lapotronicOrb);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.heatGenerator), "III", "IHI", "CGC", 'I', "plateIron", 'H',
						new ItemStack(Blocks.field_150411_aY), 'C', "circuitBasic", 'G', ModBlocks.Generator);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.Gasturbine), "IAI", "WGW", "IAI", 'I', "ingotInvar", 'A',
						TechRebornAPI.recipeCompact.getItem("advancedCircuit"), 'W',
						TechRebornAPI.recipeCompact.getItem("windMill"), 'G',
						TechRebornAPI.recipeCompact.getItem("reinforcedGlass"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.Gasturbine), "IAI", "WGW", "IAI", 'I', "ingotAluminum", 'A',
						TechRebornAPI.recipeCompact.getItem("advancedCircuit"), 'W',
						TechRebornAPI.recipeCompact.getItem("windMill"), 'G',
						TechRebornAPI.recipeCompact.getItem("reinforcedGlass"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.Semifluidgenerator), "III", "IHI", "CGC", 'I', "plateIron",
						'H', ModBlocks.reinforcedglass, 'C', ItemParts.getPartByName("electronicCircuit"), 'G',
						ModBlocks.Generator);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Semifluidgenerator), "AAA", "AHA", "CGC", 'A',
				"plateAluminum", 'H', ModBlocks.reinforcedglass, 'C', ItemParts.getPartByName("electronicCircuit"), 'G',
				ModBlocks.Generator);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.DieselGenerator), "III", "I I", "CGC", 'I', "refinedIron",
						'C', ItemParts.getPartByName("electronicCircuit"), 'G', ModBlocks.Generator);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.DieselGenerator), "AAA", "A A", "CGC", 'A', "ingotAluminum",
						'C', ItemParts.getPartByName("electronicCircuit"), 'G', ModBlocks.Generator);

		// CraftingHelper.addShapedOreRecipe(new
		// ItemStack(ModBlocks.MagicalAbsorber),
		// "CSC", "IBI", "CAC",
		// 'C', "circuitMaster",
		// 'S', "craftingSuperconductor",
		// 'B', Blocks.beacon,
		// 'A', ModBlocks.Magicenergeyconverter,
		// 'I', TechRebornAPI.recipeCompact.getItem("iridiumPlate"));
		//
		// CraftingHelper.addShapedOreRecipe(new
		// ItemStack(ModBlocks.Magicenergeyconverter),
		// "CTC", "PBP", "CLC",
		// 'C', "circuitAdvanced",
		// 'P', "platePlatinum",
		// 'B', Blocks.beacon,
		// 'L', TechRebornAPI.recipeCompact.getItem("lapotronCrystal"),
		// 'T', TechRebornAPI.recipeCompact.getItem("teleporter"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Dragoneggenergysiphoner), "CTC", "ISI", "CBC", 'I',
				TechRebornAPI.recipeCompact.getItem("iridiumPlate"), 'C', ItemParts.getPartByName("electronicCircuit"),
				'B', ModItems.lithiumBattery, 'S', ModBlocks.Supercondensator, 'T', ModBlocks.Extractor);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.centrifuge), "SCS", "BEB", "SCS", 'S', "plateSteel", 'C',
						"circuitAdvanced", 'B', TechRebornAPI.recipeCompact.getItem("advancedMachine"), 'E',
						TechRebornAPI.recipeCompact.getItem("extractor"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.BlastFurnace), "CHC", "HBH", "FHF", 'H',
				new ItemStack(ModItems.parts, 1, 17), 'C', ItemParts.getPartByName("advancedCircuit"), 'B',
				BlockMachineFrame.getFrameByName("advancedMachine", 1), 'F', ModBlocks.ElectricFurnace);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.IndustrialGrinder), "ECP", "GGG", "CBC", 'E',
				ModBlocks.IndustrialElectrolyzer, 'P', ModBlocks.Extractor, 'C',
				ItemParts.getPartByName("advancedCircuit"), 'B', TechRebornAPI.recipeCompact.getItem("advancedMachine"),
				'G', ModBlocks.Grinder);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.ImplosionCompressor), "ABA", "CPC", "ABA", 'A',
				ItemIngots.getIngotByName("advancedAlloy"), 'C', ItemParts.getPartByName("advancedCircuit"), 'B',
				BlockMachineFrame.getFrameByName("advancedMachine", 1), 'P', ModBlocks.Compressor);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.VacuumFreezer), "SPS", "CGC", "SPS", 'S', "plateSteel", 'C',
						ItemParts.getPartByName("advancedCircuit"), 'G', ModBlocks.reinforcedglass, 'P',
						ModBlocks.Extractor);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Distillationtower), "CMC", "PBP", "EME", 'E',
				ModBlocks.IndustrialElectrolyzer, 'M', "circuitMaster", 'B',
				TechRebornAPI.recipeCompact.getItem("advancedMachine"), 'C', ModBlocks.centrifuge, 'P',
				ModBlocks.Extractor);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.AlloyFurnace), "III", "F F", "III", 'I',
				ItemIngots.getIngotByName("refinediron"), 'F', new ItemStack(ModBlocks.ironFurnace));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.ChemicalReactor), "IMI", "CPC", "IEI", 'I', "ingotInvar",
						'C', ItemParts.getPartByName("advancedCircuit"), 'M', ModBlocks.Extractor, 'P',
						ModBlocks.Compressor, 'E', ModBlocks.Extractor);

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.RollingMachine), "PCP", "MBM", "PCP", 'P', Blocks.field_150331_J,
						'C', ItemParts.getPartByName("advancedCircuit"), 'M', ModBlocks.Compressor, 'B',
						BlockMachineFrame.getFrameByName("machine", 1));

		// CraftingHelper.addShapedOreRecipe(new
		// ItemStack(ModBlocks.ElectricCraftingTable),
		// "ITI", "IBI", "ICI",
		// 'I', "plateIron",
		// 'C', "circuitAdvanced",
		// 'T', "crafterWood",
		// 'B', TechRebornAPI.recipeCompact.getItem("machine"));

		// CraftingHelper.addShapedOreRecipe(new
		// ItemStack(ModBlocks.ElectricCraftingTable),
		// "ATA", "ABA", "ACA",
		// 'A', "plateAluminum",
		// 'C', "circuitAdvanced",
		// 'T', "crafterWood",
		// 'B', TechRebornAPI.recipeCompact.getItem("machine"));

		// CraftingHelper.addShapedOreRecipe(new
		// ItemStack(ModBlocks.ChunkLoader),
		// "SCS", "CMC", "SCS",
		// 'S', "plateSteel",
		// 'C', "circuitMaster",
		// 'M', new ItemStack(ModItems.parts, 1, 39));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.Lesu), " L ", "CBC", " M ", 'L', ModBlocks.lvt, 'C',
				ItemParts.getPartByName("advancedCircuit"), 'M', ModBlocks.mvt, 'B', ModBlocks.LesuStorage);

		CraftingHelper
				.addShapedOreRecipe(BlockMachineFrame.getFrameByName("highlyAdvancedMachine", 1), "CTC", "TBT", "CTC",
						'C', "ingotChrome", 'T', "ingotTitanium", 'B',
						TechRebornAPI.recipeCompact.getItem("advancedMachine"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModBlocks.MachineCasing, 4, 0), "III", "CBC", "III", 'I', "plateIron",
						'C', "circuitBasic", 'B', TechRebornAPI.recipeCompact.getItem("machine"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.MachineCasing, 4, 1), "SSS", "CBC", "SSS", 'S',
				"plateSteel", 'C', "circuitAdvanced", 'B', TechRebornAPI.recipeCompact.getItem("advancedMachine"));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.MachineCasing, 4, 2), "HHH", "CBC", "HHH", 'H',
				"ingotChrome", 'C', "circuitElite", 'B', BlockMachineFrame.getFrameByName("highlyAdvancedMachine", 1));

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.quantumChest), "DCD", "ATA", "DQD", 'D',
				ItemParts.getPartByName("dataOrb"), 'C', ItemParts.getPartByName("computerMonitor"), 'A',
				BlockMachineFrame.getFrameByName("highlyAdvancedMachine", 1), 'Q', ModBlocks.digitalChest, 'T',
				ModBlocks.Compressor);

		CraftingHelper.addShapedOreRecipe(new ItemStack(ModBlocks.PlasmaGenerator), "PPP", "PTP", "CGC", 'P',
				ItemPlates.getPlateByName("tungstensteel"), 'T', TechRebornAPI.recipeCompact.getItem("hvTransformer"),
				'G', TechRebornAPI.recipeCompact.getItem("generator"), 'C',
				ItemParts.getPartByName("energyFlowCircuit"));

		// Smetling
		GameRegistry
				.addSmelting(ItemDusts.getDustByName("copper", 1), TechRebornAPI.recipeCompact.getItem("copperIngot"),
						1F);
		GameRegistry
				.addSmelting(ItemDusts.getDustByName("tin", 1), TechRebornAPI.recipeCompact.getItem("tinIngot"), 1F);
		GameRegistry
				.addSmelting(ItemDusts.getDustByName("bronze", 1), TechRebornAPI.recipeCompact.getItem("bronzeIngot"),
						1F);
		GameRegistry
				.addSmelting(ItemDusts.getDustByName("lead", 1), TechRebornAPI.recipeCompact.getItem("leadIngot"), 1F);
		GameRegistry
				.addSmelting(ItemDusts.getDustByName("silver", 1), TechRebornAPI.recipeCompact.getItem("silverIngot"),
						1F);

		// Saw mill
		ItemStack pulpStack = OreDictionary.getOres("pulpWood").get(0);
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 0),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Blocks.field_150344_f, 6, 0), pulpStack,
				ItemCells.getCellByName("empty"), 200, 30, false));
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 0),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Blocks.field_150344_f, 6, 0), pulpStack,
				ItemCells.getCellByName("empty"), 200, 30, false));
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 2),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Blocks.field_150344_f, 6, 2), pulpStack,
				ItemCells.getCellByName("empty"), 200, 30, false));
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150364_r, 1, 3),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Blocks.field_150344_f, 6, 3), pulpStack,
				ItemCells.getCellByName("empty"), 200, 30, false));
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150363_s, 1, 0),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Blocks.field_150344_f, 6, 4), pulpStack,
				ItemCells.getCellByName("empty"), 200, 30, false));
		RecipeHandler.addRecipe(new IndustrialSawmillRecipe(new ItemStack(Blocks.field_150363_s, 1, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Blocks.field_150344_f, 6, 5), pulpStack,
				ItemCells.getCellByName("empty"), 200, 30, false));

		// UU
		if (ConfigTechReborn.UUrecipesIridiamOre)
			CraftingHelper
					.addShapedOreRecipe((TechRebornAPI.recipeCompact.getItem("iridiumOre")), "UUU", " U ", "UUU", 'U',
							ModItems.uuMatter);

		// Blast Furnace
		RecipeHandler.addRecipe(new BlastFurnaceRecipe(ItemCells.getCellByName("silicon", 2), null,
				ItemPlates.getPlateByName("silicon"), ItemCells.getCellByName("empty", 2), 1000, 120, 1500));

		// CentrifugeRecipes

		// Plantball/Bio Chaff
		// FIX with ic2
		// RecipeHandler.addRecipe(new CentrifugeRecipe(new
		// ItemStack(Blocks.grass, 16), null, new
		// ItemStack(TechRebornAPI.recipeCompact.getItem("biochaff").getItem(),
		// 8), new
		// ItemStack(TechRebornAPI.recipeCompact.getItem("plantBall").getItem(),
		// 8), new ItemStack(Items.clay_ball), new ItemStack(Blocks.sand, 8),
		// 2500, 5));
		// RecipeHandler.addRecipe(new CentrifugeRecipe(new
		// ItemStack(Blocks.dirt, 16), null, new
		// ItemStack(TechRebornAPI.recipeCompact.getItem("biochaff").getItem(),
		// 4), new
		// ItemStack(TechRebornAPI.recipeCompact.getItem("plantBall").getItem(),
		// 4), new ItemStack(Items.clay_ball), new ItemStack(Blocks.sand, 8),
		// 2500, 5));

		// Methane
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151009_A, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151034_e, 32), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151147_al, 12), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151157_am, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151025_P, 64), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151115_aP, 12), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_179566_aV, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151082_bd, 12), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151083_be, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Blocks.field_150423_aK, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151060_bw, 1), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), new ItemStack(Items.field_151074_bl, 6), null, null, 5000,
						5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151070_bp, 32), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151076_bf, 12), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151077_bg, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151078_bh, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151127_ba, 64), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151106_aX, 64), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151105_aU, 8), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151150_bK, 1), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), new ItemStack(Items.field_151074_bl, 6), null, null, 5000,
						5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151172_bF, 16), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151168_bH, 24), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(new ItemStack(Items.field_151174_bG, 16), ItemCells.getCellByName("empty"),
				ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151170_bI, 12), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151075_bm, 1), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		// Fix with ic2
		// RecipeHandler.addRecipe(new CentrifugeRecipe(new
		// ItemStack(TechRebornAPI.recipeCompact.getItem("terraWart").getItem(),
		// 16), ItemCells.getCellByName("empty"),
		// ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Blocks.field_150338_P, 1), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Blocks.field_150337_Q, 1), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("methane", 1), null, null, null, 5000, 5));

		// Rubber Wood Yields
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(TechRebornAPI.recipeCompact.getItem("rubberWood").func_77973_b(), 16),
						ItemCells.getCellByName("empty", 5), new ItemStack(ModItems.parts, 8, 41),
						new ItemStack(Blocks.field_150345_g, 6), ItemCells.getCellByName("methane", 1),
						ItemCells.getCellByName("carbon", 4), 5000, 5, false));

		// Soul Sand Byproducts
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Blocks.field_150425_aM, 16), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("oil", 1), ItemDusts.getDustByName("saltpeter", 4),
						ItemDusts.getDustByName("coal", 1), new ItemStack(Blocks.field_150354_m, 10), 2500, 5));

		// Ice
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemCells.getCellByName("ice", 1), null, new ItemStack(Blocks.field_150432_aD, 1),
						ItemCells.getCellByName("empty"), null, null, 40, 5));

		// Dust Byproducts

		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151114_aO, 16), ItemCells.getCellByName("empty"),
						new ItemStack(Items.field_151137_ax, 8), ItemDusts.getDustByName("gold", 8),
						ItemCells.getCellByName("helium", 1), null, 25000, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("phosphorous", 5), ItemCells.getCellByName("empty", 3),
						ItemCells.getCellByName("calcium", 3), null, null, null, 1280, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("ashes", 1), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("carbon"), null, null, null, 80, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(new ItemStack(Items.field_151137_ax, 10), ItemCells.getCellByName("empty", 4),
						ItemCells.getCellByName("silicon", 1), ItemDusts.getDustByName("pyrite", 3),
						ItemDusts.getDustByName("ruby", 1), ItemCells.getCellByName("mercury", 3), 6800, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("endstone", 16), ItemCells.getCellByName("empty", 2),
						ItemCells.getCellByName("helium3", 1), ItemCells.getCellByName("helium"),
						ItemDustsSmall.getSmallDustByName("Tungsten", 1), new ItemStack(Blocks.field_150354_m, 12), 4800, 5));
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemDusts.getDustByName("cinnabar", 2), ItemCells.getCellByName("empty"),
						ItemCells.getCellByName("mercury", 1), ItemDusts.getDustByName("sulfur", 1), null, null, 80,
						5));

		// Deuterium/Tritium
		RecipeHandler.addRecipe(
				new CentrifugeRecipe(ItemCells.getCellByName("helium", 16), null, ItemCells.getCellByName("helium3", 1),
						ItemCells.getCellByName("empty", 15), null, null, 10000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(ItemCells.getCellByName("deuterium", 4), null,
				ItemCells.getCellByName("tritium", 1), ItemCells.getCellByName("empty", 3), null, null, 3000, 5));
		RecipeHandler.addRecipe(new CentrifugeRecipe(ItemCells.getCellByName("hydrogen", 4), null,
				ItemCells.getCellByName("deuterium", 1), ItemCells.getCellByName("empty", 3), null, null, 3000, 5));

		// Lava Cell Byproducts
		ItemStack lavaCells = TechRebornAPI.recipeCompact.getItem("lavaCell");
		lavaCells.field_77994_a = 8;
		RecipeHandler.addRecipe(new CentrifugeRecipe(lavaCells, null, ItemNuggets.getNuggetByName("electrum", 4),
				ItemIngots.getIngotByName("copper", 2), ItemDustsSmall.getSmallDustByName("Tungsten", 1),
				ItemIngots.getIngotByName("tin", 2), 6000, 5));

		// IndustrialGrinderRecipes
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150365_q, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Items.field_151044_h, 1),
				ItemDustsSmall.getSmallDustByName("Coal", 6), ItemDustsSmall.getSmallDustByName("Coal", 2),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150366_p, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("iron", 2),
				ItemDustsSmall.getSmallDustByName("Nickel", 1), ItemDustsSmall.getSmallDustByName("Tin", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150352_o, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("gold", 2),
				ItemDustsSmall.getSmallDustByName("Copper", 1), ItemDustsSmall.getSmallDustByName("Nickel", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150366_p, 1),
				ItemCells.getCellByName("sodiumPersulfate", 1), null, ItemDusts.getDustByName("iron", 2),
				ItemDusts.getDustByName("nickel", 1), ItemDustsSmall.getSmallDustByName("Tin", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150352_o, 1),
				ItemCells.getCellByName("sodiumPersulfate", 1), null, ItemDusts.getDustByName("gold", 2),
				ItemDusts.getDustByName("copper", 1), ItemDustsSmall.getSmallDustByName("Nickel", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150352_o, 1), ItemCells.getCellByName("mercury", 1),
						null, ItemDusts.getDustByName("gold", 3), ItemDustsSmall.getSmallDustByName("Copper", 1),
						ItemDustsSmall.getSmallDustByName("Nickel", 1), ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150482_ag, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Items.field_151045_i, 1),
				ItemDustsSmall.getSmallDustByName("Diamond", 6), ItemDustsSmall.getSmallDustByName("Coal", 2),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150412_bA, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Items.field_151166_bC, 1),
				ItemDustsSmall.getSmallDustByName("Emerald", 6), ItemDustsSmall.getSmallDustByName("Aluminum", 2),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150450_ax, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Items.field_151137_ax, 10),
				ItemDustsSmall.getSmallDustByName("Cinnabar", 1), ItemDustsSmall.getSmallDustByName("Glowstone", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150369_x, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Items.field_151100_aR, 6, 4),
				ItemDustsSmall.getSmallDustByName("Lazurite", 3), null,
				ItemCells.getCellByName("empty"), 100, 120));

		// Copper Ore
		if (OreUtil.doesOreExistAndValid("oreCopper"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCopper").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("copper", 2), ItemDustsSmall.getSmallDustByName("Gold", 1),
								ItemDustsSmall.getSmallDustByName("Nickel", 1), ItemCells.getCellByName("empty"), 100,
								120));

				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("sodiumPersulfate", 1), null,
								ItemDusts.getDustByName("copper", 2), ItemDusts.getDustByName("gold", 1),
								ItemDustsSmall.getSmallDustByName("Nickel", 1), ItemCells.getCellByName("empty"), 100,
								120));

				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("mercury", 1), null,
								ItemDusts.getDustByName("copper", 2), ItemDustsSmall.getSmallDustByName("Gold", 1),
								ItemDusts.getDustByName("nickel", 1), ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Copper Ore");
			}
		}

		// Tin Ore
		if (OreUtil.doesOreExistAndValid("oreTin"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTin").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("tin", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Zinc", 1), ItemCells.getCellByName("empty"), 100,
								120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("sodiumPersulfate", 1), null,
								ItemDusts.getDustByName("tin", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("zinc", 1), ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Tin Ore");
			}
		}

		// Nickel Ore
		if (OreUtil.doesOreExistAndValid("oreNickel"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreNickel").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("nickel", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Platinum", 1), ItemCells.getCellByName("empty"), 100,
								120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("sodiumPersulfate", 1), null,
								ItemDusts.getDustByName("nickel", 3), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Platinum", 1), ItemCells.getCellByName("empty"), 100,
								120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("mercury", 1), null,
								ItemDusts.getDustByName("nickel", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("platinum", 1), ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Nickel Ore");
			}
		}

		// Zinc Ore
		if (OreUtil.doesOreExistAndValid("oreZinc"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreZinc").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("zinc", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDustsSmall.getSmallDustByName("Tin", 1), ItemCells.getCellByName("empty"), 100,
								120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("sodiumPersulfate", 1), null,
								ItemDusts.getDustByName("zinc", 2), ItemDustsSmall.getSmallDustByName("Iron", 1),
								ItemDusts.getDustByName("iron", 1), ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Zinc Ore");
			}
		}

		// Silver Ore
		if (OreUtil.doesOreExistAndValid("oreSilver"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreSilver").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("silver", 2), ItemDustsSmall.getSmallDustByName("Lead", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemCells.getCellByName("empty"), 100,
								120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("mercury", 1), null,
								ItemDusts.getDustByName("silver", 3), ItemDustsSmall.getSmallDustByName("Lead", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Silver Ore");
			}
		}

		// Lead Ore
		if (OreUtil.doesOreExistAndValid("oreLead"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreLead").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("lead", 2), ItemDustsSmall.getSmallDustByName("Silver", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemCells.getCellByName("empty"), 100,
								120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, ItemCells.getCellByName("mercury", 1), null,
								ItemDusts.getDustByName("lead", 2), ItemDusts.getDustByName("silver", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Lead Ore");
			}
		}

		// Uranium Ore
		if (OreUtil.doesOreExistAndValid("oreUranium"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreUranium").get(0);
				ItemStack uranium238Stack = TechRebornAPI.recipeCompact.getItem("Uran238");
				uranium238Stack.field_77994_a = 8;
				ItemStack uranium235Stack = TechRebornAPI.recipeCompact.getItem("smallUran235");
				uranium235Stack.field_77994_a = 2;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								uranium238Stack, uranium235Stack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								uranium238Stack, uranium235Stack, null, ItemCells.getCellByName("empty"), 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, uranium238Stack,
								uranium235Stack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Uranium Ore");
			}
		}

		// Pitchblende Ore
		if (OreUtil.doesOreExistAndValid("orePitchblende"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("orePitchblende").get(0);
				ItemStack uranium238Stack = TechRebornAPI.recipeCompact.getItem("Uran238");
				uranium238Stack.field_77994_a = 8;
				ItemStack uranium235Stack = TechRebornAPI.recipeCompact.getItem("smallUran235");
				uranium235Stack.field_77994_a = 2;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, null, new FluidStack(FluidRegistry.WATER, 1000),
								uranium238Stack, uranium235Stack, null, null, 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								uranium238Stack, uranium235Stack, null, ItemCells.getCellByName("empty"), 100, 120));
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, new ItemStack(Items.field_151131_as), null, uranium238Stack,
								uranium235Stack, null, new ItemStack(Items.field_151133_ar), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Uranium Ore");
			}
		}

		// Aluminum Ore
		if (OreUtil.doesOreExistAndValid("oreAluminum"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreAluminum").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("aluminum", 2), ItemDustsSmall.getSmallDustByName("Bauxite", 1),
								ItemDustsSmall.getSmallDustByName("Bauxite", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Lead Ore");
			}
		}

		// Ardite Ore
		if (OreUtil.doesOreExistAndValid("oreArdite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreArdite").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("ardite", 2), ItemDustsSmall.getSmallDustByName("Ardite", 1),
								ItemDustsSmall.getSmallDustByName("Ardite", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Ardite Ore");
			}
		}

		// Cobalt Ore
		if (OreUtil.doesOreExistAndValid("oreCobalt"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCobalt").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("cobalt", 2), ItemDustsSmall.getSmallDustByName("Cobalt", 1),
								ItemDustsSmall.getSmallDustByName("Cobalt", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Cobalt Ore");
			}
		}

		// Dark Iron Ore
		if (OreUtil.doesOreExistAndValid("oreDarkIron"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreDarkIron").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("darkIron", 2),
								ItemDustsSmall.getSmallDustByName("DarkIron", 1),
								ItemDustsSmall.getSmallDustByName("Iron", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Dark Iron Ore");
			}
		}

		// Cadmium Ore
		if (OreUtil.doesOreExistAndValid("oreCadmium"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCadmium").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("cadmium", 2), ItemDustsSmall.getSmallDustByName("Cadmium", 1),
								ItemDustsSmall.getSmallDustByName("Cadmium", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Cadmium Ore");
			}
		}

		// Indium Ore
		if (OreUtil.doesOreExistAndValid("oreIndium"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreIndium").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("indium", 2), ItemDustsSmall.getSmallDustByName("Indium", 1),
								ItemDustsSmall.getSmallDustByName("Indium", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Indium Ore");
			}
		}

		// Calcite Ore
		if (OreUtil.doesOreExistAndValid("oreCalcite") && OreUtil.doesOreExistAndValid("gemCalcite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCalcite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemCalcite").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, ItemDustsSmall.getSmallDustByName("Calcite", 6), null,
								ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Calcite Ore");
			}
		}

		// Magnetite Ore
		if (OreUtil.doesOreExistAndValid("oreMagnetite") && OreUtil.doesOreExistAndValid("chunkMagnetite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreMagnetite").get(0);
				ItemStack chunkStack = OreDictionary.getOres("chunkMagnetite").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								chunkStack, ItemDustsSmall.getSmallDustByName("Magnetite", 6), null,
								ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Magnetite Ore");
			}
		}

		// Graphite Ore
		if (OreUtil.doesOreExistAndValid("oreGraphite") && OreUtil.doesOreExistAndValid("chunkGraphite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreGraphite").get(0);
				ItemStack chunkStack = OreDictionary.getOres("chunkGraphite").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								chunkStack, ItemDustsSmall.getSmallDustByName("Graphite", 6), null,
								ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Graphite Ore");
			}
		}

		// Osmium Ore
		if (OreUtil.doesOreExistAndValid("oreOsmium"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreOsmium").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("osmium", 2), ItemDustsSmall.getSmallDustByName("Osmium", 1),
								ItemDustsSmall.getSmallDustByName("Osmium", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Osmium Ore");
			}
		}

		// Teslatite Ore
		if (OreUtil.doesOreExistAndValid("oreTeslatite") && OreUtil.doesOreExistAndValid("dustTeslatite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTeslatite").get(0);
				ItemStack dustStack = OreDictionary.getOres("dustTeslatite").get(0);
				dustStack.field_77994_a = 10;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								dustStack, ItemDustsSmall.getSmallDustByName("Sodalite", 1),
								ItemDustsSmall.getSmallDustByName("Glowstone", 1), ItemCells.getCellByName("empty"),
								100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Teslatite Ore");
			}
		}

		// Sulfur Ore
		if (OreUtil.doesOreExistAndValid("oreSulfur"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreSulfur").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("sulfur", 2), ItemDustsSmall.getSmallDustByName("Sulfur", 1),
								ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemCells.getCellByName("empty"), 100,
								120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Sulfur Ore");
			}
		}

		// Saltpeter Ore
		if (OreUtil.doesOreExistAndValid("oreSaltpeter"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreSaltpeter").get(0);
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								ItemDusts.getDustByName("saltpeter", 2),
								ItemDustsSmall.getSmallDustByName("Saltpeter", 1),
								ItemDustsSmall.getSmallDustByName("Saltpeter", 1), ItemCells.getCellByName("empty"),
								100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Saltpeter Ore");
			}
		}

		// Apatite Ore
		if (OreUtil.doesOreExistAndValid("oreApatite") & OreUtil.doesOreExistAndValid("gemApatite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreApatite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemApatite").get(0);
				gemStack.field_77994_a = 6;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, gemStack, ItemDustsSmall.getSmallDustByName("Phosphorous", 4),
								ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Apatite Ore");
			}
		}

		// Nether Quartz Ore
		if (OreUtil.doesOreExistAndValid("dustNetherQuartz"))
		{
			try
			{
				ItemStack dustStack = OreDictionary.getOres("dustNetherQuartz").get(0);
				dustStack.field_77994_a = 4;
				RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(Blocks.field_150449_bY, 1),
						TechRebornAPI.recipeCompact.getItem("waterCell"), null, new ItemStack(Items.field_151128_bU, 2),
						dustStack, ItemDustsSmall.getSmallDustByName("Netherrack", 2), ItemCells.getCellByName("empty"),
						100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Nether Quartz Ore");
			}
		}

		// Certus Quartz Ore
		if (OreUtil.doesOreExistAndValid("oreCertusQuartz"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreCertusQuartz").get(0);
				ItemStack gemStack = OreDictionary.getOres("crystalCertusQuartz").get(0);
				ItemStack dustStack = OreDictionary.getOres("dustCertusQuartz").get(0);
				dustStack.field_77994_a = 2;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, dustStack, null, ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Certus Quartz Ore");
			}
		}

		// Charged Certus Quartz Ore
		if (OreUtil.doesOreExistAndValid("oreChargedCertusQuartz"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreChargedCertusQuartz").get(0);
				ItemStack gemStack = OreDictionary.getOres("crystalChargedCertusQuartz").get(0);
				ItemStack dustStack = OreDictionary.getOres("dustCertusQuartz").get(0);
				dustStack.field_77994_a = 2;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, dustStack, null, ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Charged Certus Quartz Ore");
			}
		}

		// Amethyst Ore
		if (OreUtil.doesOreExistAndValid("oreAmethyst") && OreUtil.doesOreExistAndValid("gemAmethyst"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreAmethyst").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemAmethyst").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemAmethyst").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, dustStack, null, ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Certus Quartz Ore");
			}
		}

		// Topaz Ore
		if (OreUtil.doesOreExistAndValid("oreTopaz") && OreUtil.doesOreExistAndValid("gemTopaz"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTopaz").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemTopaz").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemTopaz").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, dustStack, null, ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Topaz Ore");
			}
		}

		// Tanzanite Ore
		if (OreUtil.doesOreExistAndValid("oreTanzanite") && OreUtil.doesOreExistAndValid("gemTanzanite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreTanzanite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemTanzanite").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemTanzanite").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, dustStack, null, ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Tanzanite Ore");
			}
		}

		// Malachite Ore
		if (OreUtil.doesOreExistAndValid("oreMalachite") && OreUtil.doesOreExistAndValid("gemMalachite"))
		{
			try
			{
				ItemStack oreStack = OreDictionary.getOres("oreMalachite").get(0);
				ItemStack gemStack = OreDictionary.getOres("gemMalachite").get(0);
				gemStack.field_77994_a = 2;
				ItemStack dustStack = OreDictionary.getOres("gemMalachite").get(0);
				dustStack.field_77994_a = 1;
				RecipeHandler.addRecipe(
						new IndustrialGrinderRecipe(oreStack, TechRebornAPI.recipeCompact.getItem("waterCell"), null,
								gemStack, dustStack, null, ItemCells.getCellByName("empty"), 100, 120));
			} catch (Exception e)
			{
				Core.logHelper.info("Failed to Load Grinder Recipe for Malachite Ore");
			}
		}

		// Implosion Compressor

		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemIngots.getIngotByName("iridiumAlloy"),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 8),
				TechRebornAPI.recipeCompact.getItem("iridiumPlate"), ItemDusts.getDustByName("darkAshes", 4), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("diamond", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 32),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialDiamond").func_77973_b(), 3),
				ItemDusts.getDustByName("darkAshes", 16), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("emerald", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 24),
				new ItemStack(Items.field_151166_bC, 3), ItemDusts.getDustByName("darkAshes", 12), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("sapphire", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 24),
				ItemGems.getGemByName("sapphire", 3), ItemDusts.getDustByName("darkAshes", 12), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("ruby", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 24),
				ItemGems.getGemByName("ruby", 3), ItemDusts.getDustByName("darkAshes", 12), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("yellowGarnet", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 24),
				ItemGems.getGemByName("yellowGarnet", 3), ItemDusts.getDustByName("darkAshes", 12), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("redGarnet", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 24),
				ItemGems.getGemByName("redGarnet", 3), ItemDusts.getDustByName("darkAshes", 12), 20, 30));
		RecipeHandler.addRecipe(new ImplosionCompressorRecipe(ItemDusts.getDustByName("peridot", 4),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("industrialTnt").func_77973_b(), 24),
				ItemGems.getGemByName("peridot", 3), ItemDusts.getDustByName("darkAshes", 12), 20, 30));

		// Grinder

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 0),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("galena", 2),
				ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemDustsSmall.getSmallDustByName("Silver", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 0), ItemCells.getCellByName("mercury", 1),
						null, ItemDusts.getDustByName("galena", 2), ItemDustsSmall.getSmallDustByName("Sulfur", 1),
						ItemDusts.getDustByName("silver", 1), ItemCells.getCellByName("empty"), 100, 120));

		// Iridium Ore
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 1), null,
				new FluidStack(FluidRegistry.WATER, 1000), TechRebornAPI.recipeCompact.getItem("iridiumOre"),
				ItemDustsSmall.getSmallDustByName("Platinum", 2), null, null,
				100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null,
				TechRebornAPI.recipeCompact.getItem("iridiumOre"), ItemDustsSmall.getSmallDustByName("Platinum", 2), null, ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 1), new ItemStack(Items.field_151131_as), null,
						TechRebornAPI.recipeCompact.getItem("iridiumOre"),ItemDustsSmall.getSmallDustByName("Platinum", 2), null, new ItemStack(Items.field_151133_ar), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 1), null,
				new FluidStack(ModFluids.fluidMercury, 1000), TechRebornAPI.recipeCompact.getItem("iridiumOre"),
				ItemDustsSmall.getSmallDustByName("Platinum", 2), null, null, 100,
				120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 1), ItemCells.getCellByName("mercury", 1),
						null, TechRebornAPI.recipeCompact.getItem("iridiumOre"),
						ItemDustsSmall.getSmallDustByName("Platinum", 2), null,
						ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 1), new ItemStack(ModItems.bucketMercury),
						null, TechRebornAPI.recipeCompact.getItem("iridiumOre"),
						ItemDustsSmall.getSmallDustByName("Platinum", 2), null,
						new ItemStack(Items.field_151133_ar), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 2),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemGems.getGemByName("ruby", 1),
				ItemDustsSmall.getSmallDustByName("Ruby", 6), ItemDustsSmall.getSmallDustByName("Chrome", 2),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 3),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemGems.getGemByName("sapphire", 1),
				ItemDustsSmall.getSmallDustByName("Sapphire", 6), ItemDustsSmall.getSmallDustByName("Aluminum", 2),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 4),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("bauxite", 2),
				ItemDustsSmall.getSmallDustByName("Grossular", 4), ItemDustsSmall.getSmallDustByName("Titanium", 4),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 5),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("pyrite", 2),
				ItemDustsSmall.getSmallDustByName("Sulfur", 1), ItemDustsSmall.getSmallDustByName("Phosphorous", 1),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 6),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("cinnabar", 2),
				ItemDustsSmall.getSmallDustByName("Redstone", 1), ItemDustsSmall.getSmallDustByName("Glowstone", 1),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 7),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("sphalerite", 2),
				ItemDustsSmall.getSmallDustByName("Zinc", 1), ItemDustsSmall.getSmallDustByName("YellowGarnet", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 7),
				ItemCells.getCellByName("sodiumPersulfate", 1), null, ItemDusts.getDustByName("sphalerite", 2),
				ItemDusts.getDustByName("zinc", 1), ItemDustsSmall.getSmallDustByName("YellowGarnet", 1),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 8),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("tungsten", 2),
				ItemDustsSmall.getSmallDustByName("Manganese", 1), ItemDustsSmall.getSmallDustByName("Silver", 1),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 8), ItemCells.getCellByName("mercury", 1),
						null, ItemDusts.getDustByName("tungsten", 2), ItemDustsSmall.getSmallDustByName("Manganese", 1),
						ItemDusts.getDustByName("silver", 2), ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 9),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("platinum", 2),
				ItemDusts.getDustByName("nickel", 1), ItemNuggets.getNuggetByName("iridium", 2),
				ItemCells.getCellByName("empty"), 100, 120));
		RecipeHandler.addRecipe(
				new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 9), ItemCells.getCellByName("mercury", 1),
						null, ItemDusts.getDustByName("platinum", 3), ItemDusts.getDustByName("nickel", 1), ItemNuggets.getNuggetByName("iridium", 2), ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 10),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemGems.getGemByName("peridot", 1),
				ItemDustsSmall.getSmallDustByName("Peridot", 6), ItemDustsSmall.getSmallDustByName("Pyrope", 2),
				ItemCells.getCellByName("empty"), 100, 120));

		RecipeHandler.addRecipe(new IndustrialGrinderRecipe(new ItemStack(ModBlocks.ore, 1, 11),
				TechRebornAPI.recipeCompact.getItem("waterCell"), null, ItemDusts.getDustByName("sodalite", 12),
				ItemDustsSmall.getSmallDustByName("aluminum", 3), null,
				ItemCells.getCellByName("empty"), 100, 120));

		// Chemical Reactor
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemDusts.getDustByName("calcite", 1), null,
				new ItemStack(TechRebornAPI.recipeCompact.getItem("fertilizer").func_77973_b(), 1), 100, 30));
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemDusts.getDustByName("calcite", 1),
				ItemDusts.getDustByName("phosphorous", 1),
				new ItemStack(TechRebornAPI.recipeCompact.getItem("fertilizer").func_77973_b(), 3), 100, 30));
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemCells.getCellByName("sodiumSulfide", 1),
				TechRebornAPI.recipeCompact.getItem("airCell"), ItemCells.getCellByName("sodiumPersulfate", 2), 2000,
				30));
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemCells.getCellByName("nitrocarbon", 1),
				TechRebornAPI.recipeCompact.getItem("waterCell"), ItemCells.getCellByName("glyceryl", 2), 580, 30));
		RecipeHandler.addRecipe(
				new ChemicalReactorRecipe(ItemDusts.getDustByName("calcite", 1), ItemDusts.getDustByName("sulfur", 1),
						new ItemStack(TechRebornAPI.recipeCompact.getItem("fertilizer").func_77973_b(), 2), 100, 30));
		ItemStack waterCells = TechRebornAPI.recipeCompact.getItem("waterCell").func_77946_l();
		waterCells.field_77994_a = 2;
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemCells.getCellByName("sulfur", 1), waterCells,
				ItemCells.getCellByName("sulfuricAcid", 3), 1140, 30));
		ItemStack waterCells2 = TechRebornAPI.recipeCompact.getItem("waterCell").func_77946_l();
		waterCells2.field_77994_a = 5;
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemCells.getCellByName("hydrogen", 4),
				TechRebornAPI.recipeCompact.getItem("airCell"), waterCells2, 10, 30));
		RecipeHandler.addRecipe(new ChemicalReactorRecipe(ItemCells.getCellByName("nitrogen", 1),
				TechRebornAPI.recipeCompact.getItem("airCell"), ItemCells.getCellByName("nitrogenDioxide", 2), 1240,
				30));

		// IndustrialElectrolyzer

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("sulfuricAcid", 7), null,
				ItemCells.getCellByName("hydrogen", 2), ItemDusts.getDustByName("sulfur"),
				ItemCells.getCellByName("empty", 2), ItemCells.getCellByName("empty", 3), 400, 90));

		RecipeHandler.addRecipe(
				new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("ruby", 6), ItemCells.getCellByName("empty"),
						ItemDusts.getDustByName("aluminum", 2), ItemCells.getCellByName("empty", 1),
						ItemDusts.getDustByName("chrome", 1), null, 140, 90));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("sapphire", 5),
				ItemCells.getCellByName("empty"), ItemDusts.getDustByName("aluminum", 2),
				ItemCells.getCellByName("empty", 5), null, null, 100, 60));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("nitrogenDioxide", 3), null,
				ItemCells.getCellByName("nitrogen", 1), ItemCells.getCellByName("empty", 5), null,
				ItemCells.getCellByName("empty"), 160, 60));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("sodiumSulfide", 2), null,
				ItemCells.getCellByName("sodium", 1), ItemDusts.getDustByName("sulfur", 1), null,
				ItemCells.getCellByName("empty"), 200, 60));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("peridot", 5),
				ItemCells.getCellByName("empty"), ItemDusts.getDustByName("aluminum", 2),
				ItemCells.getCellByName("empty", 5), null, null, 100, 60));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("emerald", 29),
				ItemCells.getCellByName("empty", 18), ItemCells.getCellByName("berylium", 3),
				ItemDusts.getDustByName("aluminum", 2), ItemCells.getCellByName("silicon", 6),
				ItemCells.getCellByName("empty", 9), 520, 120));

		RecipeHandler.addRecipe(
				new IndustrialElectrolyzerRecipe(new ItemStack(Items.field_151100_aR, 3, 15), ItemCells.getCellByName("empty", 1),
						null, ItemCells.getCellByName("calcium", 1), null, null, 20, 106));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("glyceryl", 20), null,
				ItemCells.getCellByName("carbon", 3), ItemCells.getCellByName("hydrogen", 5),
				ItemCells.getCellByName("nitrogen", 3), ItemCells.getCellByName("empty", 9), 800, 90));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("peridot", 9),
				ItemCells.getCellByName("empty", 4), ItemDusts.getDustByName("magnesium", 2),
				ItemDusts.getDustByName("iron"), ItemCells.getCellByName("silicon", 2),
				ItemCells.getCellByName("empty", 2), 200, 120));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("calciumCarbonate", 5), null,
				ItemCells.getCellByName("carbon"), ItemCells.getCellByName("calcium"),
				ItemCells.getCellByName("empty", 1), ItemCells.getCellByName("empty", 2), 400, 90));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("sodiumPersulfate", 6), null,
				ItemCells.getCellByName("sodium"), ItemDusts.getDustByName("sulfur"),
				ItemCells.getCellByName("empty", 2), ItemCells.getCellByName("empty", 3), 420, 90));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("pyrope", 20),
				ItemCells.getCellByName("empty", 9), ItemDusts.getDustByName("aluminum", 2),
				ItemDusts.getDustByName("magnesium", 3), ItemCells.getCellByName("silicon", 3),
				ItemCells.getCellByName("empty", 9), 400, 120));

		ItemStack sand = new ItemStack(Blocks.field_150354_m);
		sand.field_77994_a = 16;

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(sand, ItemCells.getCellByName("empty", 2),
				ItemCells.getCellByName("silicon", 1), ItemCells.getCellByName("empty", 2), null, null, 1000, 25));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("almandine", 20),
				ItemCells.getCellByName("empty", 9), ItemDusts.getDustByName("aluminum", 2),
				ItemDusts.getDustByName("iron", 3), ItemCells.getCellByName("silicon", 3),
				ItemCells.getCellByName("empty", 6), 480, 120));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("spessartine", 20),
				ItemCells.getCellByName("empty", 9), ItemDusts.getDustByName("aluminum", 2),
				ItemDusts.getDustByName("manganese", 3), ItemCells.getCellByName("silicon", 3),
				ItemCells.getCellByName("empty", 6), 480, 120));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("andradite", 20),
				ItemCells.getCellByName("empty", 12), ItemCells.getCellByName("calcium", 3),
				ItemDusts.getDustByName("iron", 2), ItemCells.getCellByName("silicon", 3),
				ItemCells.getCellByName("empty", 6), 480, 120));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("grossular", 20),
				ItemCells.getCellByName("empty", 12), ItemCells.getCellByName("calcium", 3),
				ItemDusts.getDustByName("aluminum", 2), ItemCells.getCellByName("silicon", 3),
				ItemCells.getCellByName("empty", 6), 440, 120));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("Uvarovite", 20),
				ItemCells.getCellByName("empty", 12), ItemCells.getCellByName("calcium", 3),
				ItemDusts.getDustByName("chrome", 2), ItemCells.getCellByName("silicon", 3),
				ItemCells.getCellByName("empty", 6), 480, 120));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemCells.getCellByName("empty", 6), null,
				ItemCells.getCellByName("hydrogen", 4), ItemCells.getCellByName("empty", 5),
				ItemCells.getCellByName("empty", 1), null, 100, 30));

		RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(ItemDusts.getDustByName("darkAshes"),
				ItemCells.getCellByName("empty", 2), ItemCells.getCellByName("carbon", 2), null, null, null, 20, 30));

		if (OreUtil.doesOreExistAndValid("dustSalt"))
		{
			ItemStack salt = OreDictionary.getOres("dustSalt").get(0);
			salt.field_77994_a = 2;
			RecipeHandler.addRecipe(new IndustrialElectrolyzerRecipe(salt, ItemCells.getCellByName("empty", 2),
					ItemCells.getCellByName("sodium"), ItemCells.getCellByName("chlorine"), null, null, 40, 60));
		}

		Item drill = TechRebornAPI.recipeCompact.getItem("miningDrill").func_77973_b();
		ItemStack drillStack = new ItemStack(drill, 1, OreDictionary.WILDCARD_VALUE);

		if (ConfigTechReborn.ExpensiveMacerator)
			CraftingHelper
					.addShapedOreRecipe(TechRebornAPI.recipeCompact.getItem("macerator"), "FDF", "DMD", "FCF", 'F',
							Items.field_151145_ak, 'D', Items.field_151045_i, 'M', TechRebornAPI.recipeCompact.getItem("machine"), 'C',
							TechRebornAPI.recipeCompact.getItem("electronicCircuit"));

		if (ConfigTechReborn.ExpensiveDrill)
			CraftingHelper
					.addShapedOreRecipe(TechRebornAPI.recipeCompact.getItem("miningDrill"), " S ", "SCS", "SBS", 'S',
							"ingotSteel", 'B', TechRebornAPI.recipeCompact.getItem("reBattery"), 'C',
							TechRebornAPI.recipeCompact.getItem("electronicCircuit"));

		if (ConfigTechReborn.ExpensiveDiamondDrill)
			CraftingHelper
					.addShapedOreRecipe(TechRebornAPI.recipeCompact.getItem("diamondDrill"), " D ", "DBD", "TCT", 'D',
							"diamondTR", 'T', "ingotTitanium", 'B', drillStack, 'C',
							TechRebornAPI.recipeCompact.getItem("advancedCircuit"));

		if (ConfigTechReborn.ExpensiveSolar)
			CraftingHelper
					.addShapedOreRecipe(TechRebornAPI.recipeCompact.getItem("solarPanel"), "PPP", "SZS", "CGC", 'P',
							"paneGlass", 'S', ItemPlates.getPlateByName("silicon"), 'Z',
							TechRebornAPI.recipeCompact.getItem("carbonPlate"), 'G',
							TechRebornAPI.recipeCompact.getItem("generator"), 'C',
							TechRebornAPI.recipeCompact.getItem("electronicCircuit"));

		CraftingHelper.addShapedOreRecipe(ItemIngots.getIngotByName("iridiumAlloy"), "IAI", "ADA", "IAI", 'I',
				ItemIngots.getIngotByName("iridium"), 'D', ItemDusts.getDustByName("diamond"), 'A',
				TechRebornAPI.recipeCompact.getItem("advancedAlloy"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.lithiumBatpack, 1, OreDictionary.WILDCARD_VALUE), "BCB",
						"BPB", "B B", 'B', new ItemStack(ModItems.lithiumBattery), 'P', "plateAluminum", 'C',
						TechRebornAPI.recipeCompact.getItem("advancedCircuit"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.lithiumBattery, 1, OreDictionary.WILDCARD_VALUE), " C ",
						"PFP", "PFP", 'F', ItemCells.getCellByName("lithium"), 'P', "plateAluminum", 'C',
						TechRebornAPI.recipeCompact.getItem("insulatedGoldCableItem"));

		CraftingHelper
				.addShapedOreRecipe(new ItemStack(ModItems.lapotronpack, 1, OreDictionary.WILDCARD_VALUE), "FOF", "SPS",
						"FIF", 'F', ItemParts.getPartByName("energyFlowCircuit"), 'O',
						new ItemStack(ModItems.lapotronicOrb), 'S', ItemParts.getPartByName("superConductor"), 'I',
						"ingotIridium", 'P', new ItemStack(ModItems.lapotronpack));
	}

	static void addGemToolRecipes(ItemStack gemsword, ItemStack gempick, ItemStack gemaxe, ItemStack gemHoe,
			ItemStack gemspade, ItemStack gemhelmet, ItemStack gemchestplate, ItemStack gemleggings, ItemStack gemboots,
			ItemStack gem)
	{
		CraftingHelper.addShapedOreRecipe(gemsword, " G ", " G ", " S ", 'S', Items.field_151055_y, 'G', gem);

		CraftingHelper.addShapedOreRecipe(gempick, "GGG", " S ", " S ", 'S', Items.field_151055_y, 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemaxe, " GG", " SG", " S ", 'S', Items.field_151055_y, 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemHoe, " GG", " S ", " S ", 'S', Items.field_151055_y, 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemspade, " G ", " S ", " S ", 'S', Items.field_151055_y, 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemhelmet, "GGG", "G G", "   ", 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemchestplate, "G G", "GGG", "GGG", 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemleggings, "GGG", "G G", "G G", 'G', gem);

		CraftingHelper.addShapedOreRecipe(gemboots, "   ", "G G", "G G", 'G', gem);
	}
}
